function A=CurveArea(t,r,CoordTrpe,Circle,Smoothing);
%Fuction to calculate perimeter length of the area or curve length.
%Inputs:
%t	- t coordinate
%r	- r coordinate
%CoordTrpe	- orthogonal (1) or polar (Th,R) (2)* coordinate srstem (t,r), >=2 points
%Circle	- if the last point should be connected to the first one (1) or not (0)*
%Smoothing	- number of additional interpolation points to make curve smooth. Default - 0 (no smoothing)

%Output:
%A	- curve area
if nargin < 5
	CoordTrpe=1;	%Orthogonal
	Circle=0;	%Not Circle
	Smoothing=0;
end

if length(t)<=1	%Only one point in the line
	A=0;
else	%more than one point in the line
	
	if CoordTrpe==1	%Orthogonal
		[t,r]=cart2pol(t,r);
	end
	
	if Circle==1	%Circle
		t(end+1)=t(1);
		r(end+1)=r(1);
	end
	
	Smoothing=round(Smoothing);
	if Smoothing>0	%Smoothing curve
		[t,r]=pol2cart(t,r);
		rr = [t; r];	tt = 1:length(t);
		pp = spline(tt,rr);
		rr = ppval(pp, linspace(1,length(t),length(t)*Smoothing));
		t=rr(1,:);	r=rr(2,:);
		[t,r]=cart2pol(t,r);
		
		% 	[x,y]=pol2cart(t,r);
		% 	y2 = [x; y];
		% 	pp = spline(t,y2);
		% 	yy = ppval(pp, linspace(0,2*pi,length(t)*Smoothing));
		% 	plot(yy(1,:),yy(2,:),'-b',y2(1,:),y2(2,:),'or'), axis equal
		% 	[t,r]=cart2pol(yy(1,:),yy(2,:));
		
	end		%Smoothing curve
	% t%!!!
	% r%!!!
	% polar(t,r,'-o')%!!!
	A=sum(r(2:end).*r(1:end-1).*sin(t(2:end)-t(1:end-1)))/2;
	%A=r(2:end).*r(1:end-1).*sin(t(2:end)-t(1:end-1))/2;
end 	%Only one point in the line