% fast Fourier transformation of the water filling of MscS
clear
%Load data on the number of water molecules in the channel
filename='sim_mscs-cry-chnl-big-oct-cor-l109s_wtr_f_salt_wrp.dcd.sel-atm-cnt.txt';
%filename='sim_mscs-cry-chnl-big-oct-cor_wtr_f_salt_wrp.dcd.sel-atm-cnt.txt';
%filename='sim_mscs-cry-chnl-big-oct-cor_wtr_f_wrp.dcd.sel-atm-cnt.txt';
timeline=load(filename);

%timespan=100:2500;
%timespan=200:2000;
%timespan=200:1400;
%timespan=2900:5100;
%timespan=1:6000;
timespan=1:length(timeline(:,1));

timeline=timeline(timespan,:); 
%timeline=timeline(2900:5100,:); 
%timeline=timeline(200:2000,:);
timeline(:,1)=[1:length(timeline(:,1))]';
% Avrg_length=100;	%Averaging length for the timeline
% for i=1:length(timeline)	%Averaging timeline to make it smooth
%     timeline_s(i,2)=mean(timeline(max(1,i-Avrg_length):min(length(timeline(:,1)),i+Avrg_length),2));
% end
% Avrg_length=25;	%Averaging length for the timeline
% for i=1:length(timeline)	%Averaging timeline to make it smooth
%     timeline(i,2)=mean(timeline(max(1,i-Avrg_length):min(length(timeline(:,1)),i+Avrg_length),2))-timeline_s(i,2);
% end
Avrg_length=10;	%Averaging length for the timeline
for i=1:length(timeline)	%Averaging timeline to make it smooth
    timeline(i,2)=mean(timeline(max(1,i-Avrg_length):min(length(timeline(:,1)),i+Avrg_length),2));
end
%Make FFT
timeline_fft=fft(timeline(:,2));
%The power spectrum, a measurement of the power at various frequencies, is

Pyy = timeline_fft.* conj(timeline_fft) / length(timeline_fft);

%Plot data and FFT
title_main=[filename,',   time ',num2str(min(timespan)),' to ',num2str(max(timespan)),' ps, avrg ',num2str(Avrg_length),'ps'];

figure
plot(timespan,timeline(:,2))
xlabel('Time, ps','Interpreter','none')
ylabel('N_water')
title_pic=[title_main,', N_water']; title(title_pic,'Interpreter','none')    %Picture title
tstr=['print -dpng ''',title_pic,'.png''']; eval(tstr);   %Save image to the file


figure
f=1:1+round(length(timeline_fft)/2);
hd=plot(f,Pyy(f+1));	%Plot of fourier frequencies
set(gca,'YScale','log')
set(gca,'XScale','log')
xlabel('Frequency, n/timespan','Interpreter','none')
ylabel('Power','Interpreter','none')
title_pic=[title_main,', Frequency']; title(title_pic,'Interpreter','none')    %Picture title
tstr=['print -dpng ''',title_pic,'.png''']; eval(tstr);   %Save image to the file

    
period(f)=length(timeline_fft)./f;
figure
hd=plot(period(f),Pyy(f+1));	%Plot of fourier periods
set(gca,'YScale','log')
set(gca,'XScale','log')
xlabel('Period, ps','Interpreter','none')
ylabel('Power','Interpreter','none')
title_pic=[title_main,', Period_log']; title(title_pic,'Interpreter','none')    %Picture title
tstr=['print -dpng ''',title_pic,'.png''']; eval(tstr);   %Save image to the file


figure
hd=plot(period(f),Pyy(f+1));	%Plot of fourier periods
set(gca,'YScale','log')
% set(gca,'XScale','log')
xlabel('Period, ps','Interpreter','none')
ylabel('Power','Interpreter','none')
title_pic=[title_main,', Period']; title(title_pic,'Interpreter','none')    %Picture title
tstr=['print -dpng ''',title_pic,'.png''']; eval(tstr);   %Save image to the file

