function c=find_coinc(a, b,minmax)
%Function finding all the indexes of the elements of array "a" which meet at least once in array "b"
%Inputs:
%a	- array which is compared indexed to the output
%b	- array to compare with, probe.
%minmax	- flag to make <1> or not <0>* range comparison for numeric arrays
if nargin==2	%minmax was not set
	minmax=0;	%Don't make range comparison
end

c=[];	%default empty array of coinciding elements
if  iscell(a)& iscell(b)	%a and b are both cell arrays
	if length(b)>1|length(b{1})>0	%there is something to compare with
		c=zeros(size(a));	%Initial array of "a" elements - noone was met tyet
		for t=1:length(b)
			c=strcmp(a,b{t});
% 			for k=1:length(a)
% 				if a{k}==b{t}; c(k)=1; end;
% 			end
		end
		c=find(c);
	end
elseif  isnumeric(a)& isnumeric(b)	%a and b are both numeric arrays
	if length(b)~=0
		if minmax==0	%Don't make range comparison
			c=zeros(size(a));	%Initial array of "a" elements - noone was met tyet
			for t=b
				c(a==t)=1;
			end
			c=find(c);
		else	%Make range comparison
			c=find(a>=min(b)&a<=max(b));
		end
	end
end

