function varargout = mb(varargin)
% MB Application M-file for mb.fig
%    FIG = MB launch mb GUI.
%    MB('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 03-Jul-2003 16:18:42
global mbh oph SrcDir DestDir

if nargin == 0  % LAUNCH GUI
	
	fig = openfig(mfilename,'reuse');
    % Use system color scheme for figure:
    set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

		
	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);
	
	if nargout > 0
		varargout{1} = fig;
	end
	SndNp(3);
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	
	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end
	
end
%     set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = m_FileListAdd_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
global mbh
s_old=get(findobj(mbh,'Tag','m_FileList'),'String');	%Remember old file list
m_FileListLoad_Callback
s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
for i=1:length(s)	%Combine file lists
	s_old{end+1}=s{i};
end
set(findobj(mbh,'Tag','m_FileList'),'String',s_old);	
set(findobj(mbh,'Tag','m_FileList'),'Value',1);
set(findobj(mbh,'Tag','m_FileInfo'),'String',s_old{1});


function varargout = m_FileList_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
global mbh
s=get(findobj(mbh,'Tag','m_FileList'),'String');	%
v=get(findobj(mbh,'Tag','m_FileList'),'Value');
set(findobj(mbh,'Tag','m_FileInfo'),'String',s{v});

function varargout = m_FileInfo_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
global mbh
s=get(findobj(mbh,'Tag','m_FileList'),'String');	%
v=get(findobj(mbh,'Tag','m_FileList'),'Value');
s{v}=get(findobj(mbh,'Tag','m_FileInfo'),'String');	%
set(findobj(mbh,'Tag','m_FileList'),'String',s);


function varargout = m_FileListClear_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
global mbh
set(findobj(mbh,'Tag','m_FileList'),'String',{'(None)'});
set(findobj(mbh,'Tag','m_FileInfo'),'String',{'(None)'});

function varargout = m_FileListDelete_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
global mbh
s=get(findobj(mbh,'Tag','m_FileList'),'String');	%
v=get(findobj(mbh,'Tag','m_FileList'),'Value');
for i=1:(v-1)
	sn{i}=s{i};
end
for i=(v+1):(length(s))
	sn{i-1}=s{i};
end
set(findobj(mbh,'Tag','m_FileList'),'String',sn);	%
set(findobj(mbh,'Tag','m_FileList'),'Value',max(1,(v-1)));
set(findobj(mbh,'Tag','m_FileInfo'),'String',sn{max(1,(v-1))});


function varargout = m_FileListLoad_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
global mbh SrcDir DestDir
FileType=get(findobj(mbh,'Tag','m_FileType'),'Value');
s=[];
switch FileType
case 1	%PDB
	ft='*.pdb';
case 2	%TXT
	ft='*.txt';
case 4	%MAT
	ft='*.mat';
case 5	%WRL
	ft='*.wrl';
case 6 %'*VRML.mat'
	ft='*VRML.mat';
otherwise
	ft='*.*';
end
[s,v]=uigetfiles(ft,'Select a data file:');
DestDir=v;
if ~isempty(s)
	cd(v);
	set(findobj(mbh,'Tag','m_FileInfo'),'String',s{1});
	set(findobj(mbh,'Tag','m_FileList'),'Value',1);
	set(findobj(mbh,'Tag','m_FileList'),'String',s);
end

% --------------------------------------------------------------------
function varargout = m_FileType_Callback(h, eventdata, handles, varargin)
global mbh
% Stub for Callback of the uicontrol handles.popupmenu2.




% --------------------------------------------------------------------
function varargout = m_Mode_Callback(h, eventdata, handles, varargin)
global mbh oph
% Stub for Callback of the uicontrol handles.m_Mode.
Mode=get(findobj(mbh,'Tag','m_Mode'),'Value');
m_FileListClear_Callback;
switch Mode	%Select mode of PDB analysis
	% case 1	%'(Select an analysis mode here)'
	%     	if size(oph)>0; close(oph); oph=[]; end
case 1	%'Property profile(s) creation', 
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',1);	%PDB file format
	oph=o_hydroprof;
	set(findobj(oph,'Tag','o_PlotProf'),'Value',0);	%Plot Property profiles
	set(findobj(oph,'Tag','o_PlotLand'),'Value',0);	%Plot Property landscape
	set(findobj(oph,'Tag','o_PrintProf'),'Value',0);    %Print Property profiles
	set(findobj(oph,'Tag','o_PrintLand'),'Value',0);	%Print Property landscape
	set(findobj(oph,'Tag','o_ImageProf'),'Value',0);	%Image Property profiles
	set(findobj(oph,'Tag','o_ImageLand'),'Value',0);	%Image Property landscape
	set(findobj(oph,'Tag','o_SaveProf'),'Value',1);	%Save Property profiles
	set(findobj(oph,'Tag','o_SaveLand'),'Value',1);	%Save Property landscape
	set(findobj(oph,'Tag','o_ProfileType'),'String',{'Hydrophobicity profile calculation',...
			'Charge profile calculation','Residue exposure summation'});	% hydrophobicity <1>*, electrical charge <2>, Residue exposure summation <3>
	set(findobj(oph,'Tag','o_ProfileType'),'Value',1);	%Outside surface
	set(findobj(oph,'Tag','o_ProfileGeom'),'String',{'Vertical (along Z axis)',...
			'Circular (view to positive Z direction)'});	%Select type of geometry to create profile - vertical (along Z axis) <1>*, circular (view from the Z axis, from negative to positive direction) <2>
	set(findobj(oph,'Tag','o_ProfileGeom'),'Value',1);	%vertical (along Z axis) 
	set(findobj(oph,'Tag','o_DataColumn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Column with data for calculation
	set(findobj(oph,'Tag','o_DataColumn'),'Value',12);	%Default column
	set(findobj(oph,'Tag','o_DataInclude'),'String',{'All the data', 'Positive only', 'Negative only'});	%Select data to include into the calculation - all the data <1>*, positive <2>, negative <3>
	set(findobj(oph,'Tag','o_DataInclude'),'Value',1);	%All the data
	set(findobj(oph,'Tag','o_CritColumn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Column with criterion for including into the calculation
	set(findobj(oph,'Tag','o_CritColumn'),'Value',11);	%Default column
	set(findobj(oph,'Tag','o_SelectCrit'),'String',{'1: Outside surface of the channel', '-1: Inside surface of the channel',...
			'Any: All the surface of the channel'});	%Select surface for calculation - outside <1>*, inside <2>, all <3>
	set(findobj(oph,'Tag','o_SelectCrit'),'Value',1);	%Outside surface
	set(findobj(oph,'Tag','o_GridStepType'),'String',{'Length, A','Steps'});	%Type of the calculation of slices grid steps - by the step length or number of steps
	set(findobj(oph,'Tag','o_GridStepType'),'Value',1);	%Type of the calculation of volumetric grid steps - by the step length or number of steps
	set(findobj(oph,'Tag','o_GridStep'),'String','1');	%Length of the grid step (in Angstroms) or number of steps in the grid
	set(findobj(oph,'Tag','o_RangeType'),'String',{'Auto 1st','Min:Max'});	%the way to determine min and max Z values
	set(findobj(oph,'Tag','o_RangeType'),'Value',1);	%the way to determine min and max Z values
	set(findobj(oph,'Tag','o_MinZ'),'String','-100');	%min Z value
	set(findobj(oph,'Tag','o_MaxZ'),'String','100');	%max Z value
	
case 2	%'Property profile(s) analysis',
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',2);	%TXT file format
	oph=o_hydpran;
	set(findobj(oph,'Tag','o_PlotProf'),'Value',0);	%Plot Property profiles
	set(findobj(oph,'Tag','o_PlotLand'),'Value',0);	%Plot Property landscape
	set(findobj(oph,'Tag','o_PrintProf'),'Value',0);    %Print Property profiles
	set(findobj(oph,'Tag','o_PrintLand'),'Value',0);	%Print Property landscape
	set(findobj(oph,'Tag','o_ImageProf'),'Value',0);	%Image Property profiles
	set(findobj(oph,'Tag','o_ImageLand'),'Value',0);	%Image Property landscape
	set(findobj(oph,'Tag','o_SaveProf'),'Value',1);	%Save Property profiles
	set(findobj(oph,'Tag','o_SaveLand'),'Value',1);	%Save Property landscape
	set(findobj(oph,'Tag','o_AverNeighb'),'String','1');	%Averaging among ... neighbors
	set(findobj(oph,'Tag','o_AverMode'),'String',{'Mean of ... neighbors', 'A-shaped mean of ... neighbors',...
			'Profile of neighbor bins with coefficients ... (from center to edge)',...
			'Normal distribution with standard deviation of ... A'});	%Averaging mode
	set(findobj(oph,'Tag','o_AverOutside'),'Value',2);	%Save Property landscape
	set(findobj(oph,'Tag','o_AverOutside'),'String',{'Do not average boarding bins','Average boarding bins (with outside as 0)','Circular averaging'});	%Save Property landscape
	
	
case 3	%'PDB column replacement'
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',1);	%PDB file format
	oph=o_pdbadcol;
	set(findobj(oph,'Tag','o_FileType'),'String',{'*.pdb', '*.txt column', '*.txt GETAREA', '*.*','*.txt profile'});
	set(findobj(oph,'Tag','o_FileType'),'Value',2);
	
	set(findobj(oph,'Tag','o_DataType'),'String',{'Per residue','Per atom'});	%Data type (per residue, per atom) in source file
	set(findobj(oph,'Tag','o_DataOligo'),'String',{'Monomer','Oligomer'});	%Data per monomer or per whole oligomer in source file
	
	set(findobj(oph,'Tag','o_SrcColn'),'String',{'(Default)'});	%Source column with data 
	set(findobj(oph,'Tag','o_DestColn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Destination column for data 
	set(findobj(oph,'Tag','o_DestColn'),'Value',12);	%Destination column for data - beta
	
case 4	%'PDB residues renumbering' - renumber residues in order they meet, all the atoms with the same residue number will receive the same new number
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',1);	%PDB file format
	oph=o_pdbrenumres;
	set(findobj(oph,'Tag','o_DestColn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Destination column for data 
	set(findobj(oph,'Tag','o_DestColn'),'Value',6);	%Destination column for data - resid
	
case 5	%'Property profile(s) combining',
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',2);	%TXT file format
	oph=o_hydprcomb;
	set(findobj(oph,'Tag','o_PlotProf'),'Value',1);	%Plot Property profiles
	set(findobj(oph,'Tag','o_PlotLand'),'Value',1);	%Plot Property landscape
	set(findobj(oph,'Tag','o_SaveProf'),'Value',1);	%Save Property profiles
	set(findobj(oph,'Tag','o_SaveLand'),'Value',1);	%Save Property landscape
	set(findobj(oph,'Tag','o_CombMode'),'String',{'Sum','Subtract (Ini-Comb)',...
			'Subtract (Comb-Ini)','Multiply','Divide (Ini/Comb)', 'Divide (Comb/Ini)','Average (Ini)','Rebin (Ini by Comb)','Rebin spline (Ini by Comb)'});	%Combining mode
	set(findobj(oph,'Tag','o_CombFileType'),'String',{'*.txt', '*.*'});
	set(findobj(oph,'Tag','o_CombFileType'),'Value',1);
	
case 6	%'PDB structure reorientation' - reorient structure according to selected reorientation type and criteria
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',1);	%PDB file format
	oph=o_pdbreorient;
	set(findobj(oph,'Tag','o_ReorientMode'),'String',{'Alpha-spiral along Z axis'})
	set(findobj(oph,'Tag','o_ReorientMode'),'Value',1);	%Alpha-spiral reorientation mode
	set(findobj(oph,'Tag','o_PlotResult'),'Value',1);	%Plot the result of reorientation
	set(findobj(oph,'Tag','o_SelctnColn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Selection column
	set(findobj(oph,'Tag','o_SelctnColn'),'Value',1);	%Selection column - index
	set(findobj(oph,'Tag','o_SelctnCrit'),'String','');
	set(findobj(oph,'Tag','o_CritCombMode'),'String',{'AND', 'OR', 'Selected criterion'})
	set(findobj(oph,'Tag','o_CritCombMode'),'Value',1);	%Criterion combination mode - last criterion
	set(findobj(oph,'Tag','o_CriteriaList'),'String',{'','CA','','','','','','','','','','','','','',''})
	set(findobj(oph,'Tag','o_CriteriaList'),'Value',1);	%Criteria list - index
case 7 %'PDB property 3D averaging'
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',1);	%PDB file format
	oph=o_prop3davrg;
	set(findobj(oph,'Tag','o_DistrType'),'String',{'Add value to every atom in the bin',...
			'Divide value equally between the atoms in the bin','Divide value proportionnaly between the atoms in the bin'});	% distribution type
	set(findobj(oph,'Tag','o_DistrType'),'Value',1);	%Outside surface
	set(findobj(oph,'Tag','o_DataColumn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Column with data for calculation
	set(findobj(oph,'Tag','o_DataColumn'),'Value',12);	%Default column
	set(findobj(oph,'Tag','o_DataInclude'),'String',{'All the data', 'Positive only', 'Negative only'});	%Select data to include into the calculation - all the data <1>*, positive <2>, negative <3>
	set(findobj(oph,'Tag','o_DataInclude'),'Value',1);	%All the data
	set(findobj(oph,'Tag','o_CritColumn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Column with criterion for including into the calculation
	set(findobj(oph,'Tag','o_CritColumn'),'Value',15);	%Default column
	set(findobj(oph,'Tag','o_SelectCrit'),'String',{'1: Outside surface of the channel', '-1: Inside surface of the channel',...
			'Any: All the surface of the channel'});	%Select surface for calculation - outside <1>*, inside <2>, all <3>
	set(findobj(oph,'Tag','o_SelectCrit'),'Value',1);	%Outside surface
	set(findobj(oph,'Tag','o_CoefColumn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Column with coefficients to multiply parameter value. By default - exposed atom area
	set(findobj(oph,'Tag','o_CoefColumn'),'Value',11);	%Default column
	set(findobj(oph,'Tag','o_CoefInclude'),'String',{'Positive', '>50% of possible atom area',...
			'Any exposed area'});	%Select surface for calculation - outside <1>*, inside <2>, all <3>
	set(findobj(oph,'Tag','o_CoefInclude'),'Value',1);	%All the atoms with some exposed area
	set(findobj(oph,'Tag','o_BinWidth'),'String','1');	%Width of bins
	set(findobj(oph,'Tag','o_AverNeighb'),'String','1');	%Averaging among ... neighbors
	set(findobj(oph,'Tag','o_AverMode'),'String',{'Mean of ... neighbors', 'A-shaped mean of ... neighbors',...
			'Profile of neighbor bins with coefficients ... (from center to edge)',...
			'Normal distribution with standard deviation of ... A'});	%Averaging mode
case 8	%'Volumetric data creation'
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',1);	%PDB file format
	oph=o_pdbmkvolm;
	set(findobj(oph,'Tag','o_VDWFileType'),'String',{'*.pdb', '*.txt column', '*.psf', '*.*'});	%Format and type of the file with data of VDW radii
	set(findobj(oph,'Tag','o_VDWFileType'),'Value',2);	%Format and type of the file with data of VDW radii
	set(findobj(oph,'Tag','o_OutFileType'),'String',{'*.mat','*.txt'});	%Format of output file with volumetric data
	set(findobj(oph,'Tag','o_OutFileType'),'Value',1);	%Format of output file with volumetric data
	set(findobj(oph,'Tag','o_ZIPoutput'),'Value',0);	%Flag to pack reasonably selected oputput files into zip archives
	set(findobj(oph,'Tag','o_GridStepType'),'String',{'Length, A','Steps'});	%Type of the calculation of volumetric grid steps - by the step length or number of steps
	set(findobj(oph,'Tag','o_GridStepType'),'Value',1);	%Type of the calculation of volumetric grid steps - by the step length or number of steps
	set(findobj(oph,'Tag','o_GridStep'),'String','1');	%Length of the grid step (in Angstroms) or number of steps in the grid
	set(findobj(oph,'Tag','o_ProbeSurfType'),'String',{'No probe','Center of probe','Surface of probe'});	%Is surface created by the probe center or probe surface trajectory
	set(findobj(oph,'Tag','o_ProbeSurfType'),'Value',1);	%Is surface created by the probe center or probe surface trajectory
	set(findobj(oph,'Tag','o_PlotSurfLevel'),'String','0.001');	%Level of probability to see an atom at which plot molecular surface
	set(findobj(oph,'Tag','o_PlotSurf'),'Value',1);	%Flag to plot molecular surface
	set(findobj(oph,'Tag','o_SmoothNeighb'),'String',{'No smoothing','Gaussian w/std','Multi 1-neighbor'});	%Option don't smooth the data, use Gaussian smoothing of volumetric data or multiple 1-neighbor smoothing 
	set(findobj(oph,'Tag','o_SmoothNeighb'),'Value',1);	%Option don't smooth the data, use Gaussian smoothing of volumetric data or multiple 1-neighbor smoothing 
	set(findobj(oph,'Tag','o_SmoothNeighbRange'),'String','3');	%Range of neighbor bins for Gaussian smoothing of volumetric data
	set(findobj(oph,'Tag','o_AutoMatrix'),'Value',1);	%Autodetect matrix size from PDB coordinates 
	set(findobj(oph,'Tag','o_XFrom'),'String','-10');	%Matrix beginning in X direction
	set(findobj(oph,'Tag','o_XTo'),'String','10');	%Matrix end in X direction
	set(findobj(oph,'Tag','o_YFrom'),'String','-10');	%Matrix beginning in X direction
	set(findobj(oph,'Tag','o_YTo'),'String','10');	%Matrix end in Y direction
	set(findobj(oph,'Tag','o_ZFrom'),'String','-10');	%Matrix beginning in X direction
	set(findobj(oph,'Tag','o_ZTo'),'String','10');	%Matrix end in Z direction
	set(findobj(oph,'Tag','o_ProbeRadius'),'String','1.4');	%Radius of the probe to create the molecular surface
	set(findobj(oph,'Tag','o_MeanOfAllPDBs'),'String','1');	%Flag to average the data from every ... PDB files submitted into one volumetric matrix
	set(findobj(oph,'Tag','o_VDWRadiusSource'),'String',{'Guess VDW radii using atom names',...
			'VDW radii in the column of orig. PDB structure',...
			'VDW radii in the separate file','Zero VDW radii assigned for all the atoms'});	%Source of data for assigning VDW radius for PDB atoms
	set(findobj(oph,'Tag','o_VDWRadiusSource'),'Value',3)	%Source of data for assigning VDW radius for PDB atoms
	set(findobj(oph,'Tag','o_DataOligo'),'String',{'Data per Monomer','Data per Oligomer',...
			'Data per atom type'});	%Data per monomer, per whole oligomer, or per atom type  in source file
	set(findobj(oph,'Tag','o_DataOligo'),'Value',3);	%Data per monomer, per whole oligomer, or per atom type  in source file
	set(findobj(oph,'Tag','o_SrcColn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Source column for data if pdb file (initial or separate) is used to provide VDW radii data
	set(findobj(oph,'Tag','o_SrcColn'),'Value',12);	%Default Source column for VDW radius data - beta
case 9	%'Crossection area calculation by voulmetric data'
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',4);	%binary MAT (MatLab) file format
	oph=o_volmcros;
	set(findobj(oph,'Tag','o_PlotSurf'),'Value',0);	%Flag to plot molecular surfaces
	set(findobj(oph,'Tag','o_PlotCrosContr'),'Value',0);	%Flag to plot calculated contours
	set(findobj(oph,'Tag','o_PlotCrosAreas'),'Value',0);	%Flag to plot crossections areas
	set(findobj(oph,'Tag','o_PlotCrosRadii'),'Value',0);	%Flag to plot crossections radii
	set(findobj(oph,'Tag','o_PlotCrosPerim'),'Value',0);	%Flag to plot crossections perimeter length
	set(findobj(oph,'Tag','o_PrintSurf'),'Value',0);	%Flag to Print molecular surfaces
	set(findobj(oph,'Tag','o_PrintCrosContr'),'Value',0);	%Flag to Print calculated contours
	set(findobj(oph,'Tag','o_PrintCrosAreas'),'Value',0);	%Flag to Print crossections areas
	set(findobj(oph,'Tag','o_PrintCrosRadii'),'Value',0);	%Flag to Print crossections radii
	set(findobj(oph,'Tag','o_PrintCrosPerim'),'Value',0);	%Flag to Print crossections perimeter length
	set(findobj(oph,'Tag','o_ImageSurf'),'Value',1);	%Flag to Image molecular surfaces
	set(findobj(oph,'Tag','o_ImageCrosContr'),'Value',1);	%Flag to Image calculated contours
	set(findobj(oph,'Tag','o_ImageCrosAreas'),'Value',1);	%Flag to Image crossections areas
	set(findobj(oph,'Tag','o_ImageCrosRadii'),'Value',1);	%Flag to Image crossections radii
	set(findobj(oph,'Tag','o_ImageCrosPerim'),'Value',1);	%Flag to Image crossections perimeter length
	set(findobj(oph,'Tag','o_SaveSurf'),'Value',1);	%Flag to save in file the calculated surfaces
	set(findobj(oph,'Tag','o_SaveSurf'),'String',{'Do not save surfaces','Save surfaces as *_VRML.mat','Save surfaces as text triangles'});	%SaveSurf	- Option not to save <1> or save in file the calculated surfaces as VRML.mat <1> or text triangles <2>
	set(findobj(oph,'Tag','o_SaveCrosContr'),'Value',0);	%Flag to save in file the calculated crossections contours
	set(findobj(oph,'Tag','o_SaveCrosAreas'),'Value',1);	%Flag to save in file the calculated crossections areas
	set(findobj(oph,'Tag','o_SaveCrosRadii'),'Value',1);	%Flag to save in file the calculated crossections radii
	set(findobj(oph,'Tag','o_SaveCrosPerim'),'Value',1);	%Flag to save in file the calculated crossections perimeter length
	set(findobj(oph,'Tag','o_ZIPoutput'),'Value',0);	%Flag to pack reasonably selected oputput files into zip archives
	set(findobj(oph,'Tag','o_CrosNormalType'),'String',{'X axis','Y axis','Z axis','Custom vector'});	%Type of the normal to the crossection plane
	set(findobj(oph,'Tag','o_CrosNormalType'),'Value',3);	%Type of the normal to the crossection plane
	set(findobj(oph,'Tag','o_CrosNormal'),'String','0 0 1');	%X,Y,Z values for the custom Normal to the crossection planes
	set(findobj(oph,'Tag','o_PlotContourLevel'),'String','0.001');	%Data per monomer or per whole oligomer in source file
	set(findobj(oph,'Tag','o_GridStepType'),'String',{'Length, A','Steps'});	%Type of the calculation of slices grid steps - by the step length or number of steps
	set(findobj(oph,'Tag','o_GridStepType'),'Value',1);	%Type of the calculation of slices grid steps - by the step length or number of steps
	set(findobj(oph,'Tag','o_CalcMethod'),'String',{'By volumetric density crossection (*.mat)',...
			'By closest-farest points (PDB, VRML, *.mat)','By surface crossection point (VRML, *.mat)',...
			'By "umbrella touch"(PDB, VRML, *.mat)','By histogram method(PDB, VRML, *.mat)'});	%Method of the calculation of slices crossection area
	set(findobj(oph,'Tag','o_CalcMethod'),'Value',1);	%Method of the calculation of slices crossection area
	set(findobj(oph,'Tag','o_SortMethod'),'String',{'By the average radius, descending',...
			'By the closest contour in previous crossection','Both radius and closest contour'});	%Method of sorting the contours in the list for every slice
	set(findobj(oph,'Tag','o_SortMethod'),'Value',1);	%Method of sorting the contours in the list for every slice
	set(findobj(oph,'Tag','o_GridStep'),'String','1');	%Length of the grid step (in Angstroms) or number of steps in the grid
	set(findobj(oph,'Tag','o_SectNum'),'String','100');	%Number of sectors in crossection contour
	set(findobj(oph,'Tag','o_VDWRadiusSource'),'String',{'Guess VDW radii using atom names',...
			'VDW radii in the column of orig. PDB structure',...
			'VDW radii in the separate file','Zero VDW radii assigned for all the atoms'});	%Source of data for assigning VDW radius for PDB atoms
	set(findobj(oph,'Tag','o_VDWRadiusSource'),'Value',3)	%Source of data for assigning VDW radius for PDB atoms
	set(findobj(oph,'Tag','o_VDWFileType'),'String',{'*.pdb', '*.txt column', '*.psf', '*.*'});	%Format and type of the file with data of VDW radii
	set(findobj(oph,'Tag','o_VDWFileType'),'Value',2);	%Format and type of the file with data of VDW radii
	set(findobj(oph,'Tag','o_DataOligo'),'String',{'Data per Monomer','Data per Oligomer',...
			'Data per atom type'});	%Data per monomer, per whole oligomer, or per atom type  in source file
	set(findobj(oph,'Tag','o_DataOligo'),'Value',3);	%Data per monomer, per whole oligomer, or per atom type  in source file
	set(findobj(oph,'Tag','o_SrcColn'),'String',{ ...
			'.index - Atom serial number (5i)'...
			'.name - Atom name. (4s)'...
			'.altloc - Alternate location indicator. (1c)'...
			'.resname - Residue name. (3s)'...
			'.chain - Chain identifier. (1c)'...
			'.resid - Residue sequence number. (4i)'...
			'.icode - Code for insertion of residues. (1c)'...
			'.x - Orthogonal coordinates for X in Angstroms. (8.3f)'...
			'.y - Orthogonal coordinates for Y in Angstroms. (8.3f)'...
			'.z - Orthogonal coordinates for Z in Angstroms. (8.3f)'...
			'.occupancy - Occupancy. (6.?f)'...
			'.beta - Temperature factor. (6.?f)'...
			'.segname - Segment identifier, left-justified. (4s)'...
			'.element - Element symbol, right-justified. (2s)'...
			'.charge - Charge on the atom. (2s)'});	%Source column for data if pdb file (initial or separate) is used to provide VDW radii data
	set(findobj(oph,'Tag','o_SrcColn'),'Value',12);	%Default Source column for VDW radius data - beta
case 10	%'Channel conductance calculation by radius profile',
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',2);	%TXT file format
	oph=o_condprof;
	set(findobj(oph,'Tag','o_PlotProf'),'Value',0);	%Plot Property profiles
	set(findobj(oph,'Tag','o_PlotLand'),'Value',0);	%Plot Property landscape
	set(findobj(oph,'Tag','o_PrintProf'),'Value',0);    %Print Property profiles
	set(findobj(oph,'Tag','o_PrintLand'),'Value',0);	%Print Property landscape
	set(findobj(oph,'Tag','o_ImageProf'),'Value',0);	%Image Property profiles
	set(findobj(oph,'Tag','o_ImageLand'),'Value',0);	%Image Property landscape
	set(findobj(oph,'Tag','o_SaveProf'),'Value',1);	%Save Property profiles
	set(findobj(oph,'Tag','o_SaveLand'),'Value',1);	%Save Property landscape
	set(findobj(oph,'Tag','o_CondParm'),'String','31.23');	%Value of conductivity
	set(findobj(oph,'Tag','o_HydrShell'),'String','2.8');	%Hydration shell thickness
	set(findobj(oph,'Tag','o_CondParmType'),'String',{'Solution Conductivity, mS/cm'});	%Type of conductivity parameter
	set(findobj(oph,'Tag','o_ProfType'),'Value',1);	%Geometrical profile type
	set(findobj(oph,'Tag','o_ProfType'),'String',{'Given: Profile of Radius, Angstrom', 'Given: Profile of Area, Angsrom^2'});	%Geometrical profile type
case 11	%'Volumetric data visualization'
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',4);	%mat file format
	oph=o_volmvis;
	set(findobj(oph,'Tag','o_CrosNormalType'),'String',{'X axis','Y axis','Z axis','Custom vector'});	%Type of the normal to the crossection plane
	set(findobj(oph,'Tag','o_CrosNormalType'),'Value',3);	%Type of the normal to the crossection plane
	set(findobj(oph,'Tag','o_CrosNormal'),'String','0 0 1');	%X,Y,Z values for the custom Normal to the crossection planes
	set(findobj(oph,'Tag','o_CrosType'),'String',{'Average between 2 palallel planes','Average within a cylinder sector','Surfaces at probability levels','Sum between 2 palallel planes','Sum within a cylinder sector'});	%Type of the crossection cutting
	set(findobj(oph,'Tag','o_CrosType'),'Value',1);	%Type of the crossection cutting
	set(findobj(oph,'Tag','o_FromChng'),'String','');	%change rate for minimal value for crossection scan range
	set(findobj(oph,'Tag','o_ToChng'),'String','');	%change rate for maximal value for crossection scan range
	set(findobj(oph,'Tag','o_FromEdit'),'String','-1');	%minimal value for crossection scan range
	set(findobj(oph,'Tag','o_ToEdit'),'String','1');	%maximal value for crossection scan range
	set(findobj(oph,'Tag','o_FromAuto'),'Value',1);	%Autodetect minimal value for crossection scan range
	set(findobj(oph,'Tag','o_ToAuto'),'Value',1);	%Autodetect maximal value for crossection scan range
	set(findobj(oph,'Tag','o_PlotResult'),'Value',1);	%Plot the result of the calculation
	set(findobj(oph,'Tag','o_PrintResult'),'Value',0);	%Print the result of the calculation
	set(findobj(oph,'Tag','o_ImageResult'),'Value',0);	%Image file of the result of the calculation
	set(findobj(oph,'Tag','o_SaveResult'),'Value',0);	%Save the result of the calculation
	set(findobj(oph,'Tag','o_Symmetry'),'String','1');	%Symmetry of the system to be taken into account - slice will be averaged n-fold
    set(findobj(oph,'Tag','o_AutoPlotMinMax'),'Value',1);	%Autodetect minimal and maximal value for the plot scale and coloring
    set(findobj(oph,'Tag','o_PlotMin'),'String',0);	%Set minimal value for the plot scale and coloring
    set(findobj(oph,'Tag','o_PlotMax'),'String',1);	%Set maximal value for the plot scale and coloring

	%Linear crossection of the preselected slice
	set(findobj(oph,'Tag','o_MakeLinCros'),'Value',0);	%Make Linear crossection of the preselected slice
	set(findobj(oph,'Tag','o_CrosNormalTypeLin'),'String',{'X axis','Y axis','Custom vector'});	%Type of the normal to the crossection plane
	set(findobj(oph,'Tag','o_CrosNormalTypeLin'),'Value',1);	%Type of the normal to the crossection plane
	set(findobj(oph,'Tag','o_CrosNormalLin'),'String','0 0 1');	%X,Y,Z values for the custom Normal to the crossection planes
	set(findobj(oph,'Tag','o_CrosTypeLin'),'String',{'Average between 2 palallel lines','Average within a circular sector','Contours at probability levels','Sum between 2 palallel lines',...
			'Sum within a circular sector','Average profile along the circle','Sum profile along the circle'});	%Type of the crossection cutting
	set(findobj(oph,'Tag','o_CrosTypeLin'),'Value',1);	%Type of the crossection cutting
	set(findobj(oph,'Tag','o_FromChngLin'),'String','');	%change rate for minimal value for crossection scan range
	set(findobj(oph,'Tag','o_ToChngLin'),'String','');	%change rate for maximal value for crossection scan range
	set(findobj(oph,'Tag','o_FromEditLin'),'String','-1');	%minimal value for crossection scan range
	set(findobj(oph,'Tag','o_ToEditLin'),'String','1');	%maximal value for crossection scan range
	set(findobj(oph,'Tag','o_FromAutoLin'),'Value',1);	%Autodetect minimal value for crossection scan range
	set(findobj(oph,'Tag','o_ToAutoLin'),'Value',1);	%Autodetect maximal value for crossection scan range
	set(findobj(oph,'Tag','o_PlotResultLin'),'Value',1);	%Plot the result of the calculation
	set(findobj(oph,'Tag','o_PrintResultLin'),'Value',0);	%Print the result of the calculation
	set(findobj(oph,'Tag','o_ImageResultLin'),'Value',0);	%Image file of the result of the calculation
	set(findobj(oph,'Tag','o_SaveResultLin'),'Value',0);	%Save the result of the calculation
	set(findobj(oph,'Tag','o_SymmetryLin'),'String','1');	%Symmetry of the system to be taken into account - slice will be averaged n-fold
    set(findobj(oph,'Tag','o_AutoPlotMinMaxLin'),'Value',1);	%Autodetect minimal and maximal value for the linear plot scale and coloring
    set(findobj(oph,'Tag','o_PlotMinLin'),'String',0);	%Set minimal value for the linear plot scale and coloring
    set(findobj(oph,'Tag','o_PlotMaxLin'),'String',1);	%Set maximal value for the linear plot scale and coloring

case 12	%'Volumetric data combining'
	if size(oph)>0; try; close(oph); end; end
	set(findobj(mbh,'Tag','m_FileType'),'Value',4);	%mat file format
	oph=o_volmcomb;
	set(findobj(oph,'Tag','o_CombMode'),'String',{'Average','Add','Divide second by first'});	%Mode of volumetric matrixes combining
	set(findobj(oph,'Tag','o_CombMode'),'Value',1);		%Mode of volumetric matrixes combining
	set(findobj(oph,'Tag','o_ZIPoutput'),'Value',0);	%Flag to pack reasonably selected oputput files into zip archives
    o_volmcomb('o_FileListSync_Callback');    %Initial synchronisation of the weightlist with the filelist
end

%================== Start execution
function varargout = m_Start_Callback(h, eventdata, handles, varargin)
global mbh oph SrcDir DestDir

cd(DestDir)
Mode=get(findobj(mbh,'Tag','m_Mode'),'Value');
switch Mode	%Select mode of PDB analysis
case 1	%'Property profile(s) creation', 
	PlotProf=get(findobj(oph,'Tag','o_PlotProf'),'Value');	%Plot Property profiles
	PlotLand=get(findobj(oph,'Tag','o_PlotLand'),'Value');	%Plot Property landscape
	PrintProf=get(findobj(oph,'Tag','o_PrintProf'),'Value');	%Print Property profiles
	PrintLand=get(findobj(oph,'Tag','o_PrintLand'),'Value');	%Print Property landscape
	ImageProf=get(findobj(oph,'Tag','o_ImageProf'),'Value');	%Image Property profiles
	ImageLand=get(findobj(oph,'Tag','o_ImageLand'),'Value');	%Image Property landscape
	SaveProf=get(findobj(oph,'Tag','o_SaveProf'),'Value');	%Save Property profiles
	SaveLand=get(findobj(oph,'Tag','o_SaveLand'),'Value');	%Save Property landscape
	ProfileType=get(findobj(oph,'Tag','o_ProfileType'),'Value');	% hydrophobicity <1>*, electrical charge <2>, Residue exposure summation <3>
	DataColumn=get(findobj(oph,'Tag','o_DataColumn'),'Value');	%Column with data for calculation
	DataInclude=get(findobj(oph,'Tag','o_DataInclude'),'Value');	%Select data to include into the calculation - all the data <1>*, positive <2>, negative <3>
	CritColumn=get(findobj(oph,'Tag','o_CritColumn'),'Value');	%Column with criterion for including into the calculation
	SelectCrit=get(findobj(oph,'Tag','o_SelectCrit'),'Value');	%Select surface for calculation - outside <1>*, inside <2>, all <3>
	ProfileGeom=get(findobj(oph,'Tag','o_ProfileGeom'),'Value');		%Select type of geometry to create profile - vertical (along Z axis) <1>*, circular (view from the Z axis, from negative to positive direction) <2>
	GridStepType=get(findobj(oph,'Tag','o_GridStepType'),'Value');	%Type of the calculation of volumetric grid steps - by the step length or number of steps
	GridStep=eval(get(findobj(oph,'Tag','o_GridStep'),'String'));	%Length of the grid step (in Angstroms) or number of steps in the grid
	RangeType=get(findobj(oph,'Tag','o_RangeType'),'Value');	%the way to determine min and max Z values
	MinZ=eval(get(findobj(oph,'Tag','o_MinZ'),'String'));	%min Z value
	MaxZ=eval(get(findobj(oph,'Tag','o_MaxZ'),'String'));	%max Z value

    s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	
	[MBinsZ,HydEn]=hydroprof(s,SaveProf,PlotProf,SaveLand,PlotLand,PrintProf,PrintLand,ImageProf,ImageLand,ProfileType,DataColumn,...
		DataInclude,CritColumn,SelectCrit,ProfileGeom,GridStepType,GridStep,RangeType,MinZ,MaxZ);	%Call function calculating Property profile
	
case 2	%'Property profile(s) averaging',
	PlotProf=get(findobj(oph,'Tag','o_PlotProf'),'Value');	%Plot Property profiles
	PlotLand=get(findobj(oph,'Tag','o_PlotLand'),'Value');	%Plot Property landscape
	PrintProf=get(findobj(oph,'Tag','o_PrintProf'),'Value');	%Print Property profiles
	PrintLand=get(findobj(oph,'Tag','o_PrintLand'),'Value');	%Print Property landscape
	ImageProf=get(findobj(oph,'Tag','o_ImageProf'),'Value');	%Image Property profiles
	ImageLand=get(findobj(oph,'Tag','o_ImageLand'),'Value');	%Image Property landscape
	SaveProf=get(findobj(oph,'Tag','o_SaveProf'),'Value');	%Save Property profiles
	SaveLand=get(findobj(oph,'Tag','o_SaveLand'),'Value');	%Save Property landscape
	AverNeighb=eval(['[',get(findobj(oph,'Tag','o_AverNeighb'),'String'),']']);	%Averaging among ... neighbors
	AverMode=get(findobj(oph,'Tag','o_AverMode'),'Value');	%Averaging mode
	AverOutside=get(findobj(oph,'Tag','o_AverOutside'),'Value');	%Averaging boarding bins with outside as 0
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	
	[MBinsZ,HydEn]=hydpran(s,PlotProf,PlotLand,PrintProf,PrintLand,ImageProf,ImageLand,SaveProf,SaveLand,AverNeighb,AverMode,AverOutside);	%Call function calculating Property profile
	
case 3	%'PDB column replacement'
	DestFileType=get(findobj(mbh,'Tag','m_FileType'),'Value');	%PDB file format
	SrcFileType=get(findobj(oph,'Tag','o_FileType'),'Value');	%Source file format
	
	DataType=get(findobj(oph,'Tag','o_DataType'),'Value');	%Data type (per residue, per atom) in source file
	DataOligo=get(findobj(oph,'Tag','o_DataOligo'),'Value');	%Data per monomer or per whole oligomer in source file
	
	SrcColn=get(findobj(oph,'Tag','o_SrcColn'),'Value');	%Source column with data 
	DestColn=get(findobj(oph,'Tag','o_DestColn'),'Value');	%Destination column for data
	
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	
	SrcFile=get(findobj(oph,'Tag','o_FileInfo'),'String');	%Get source file
	
	pdbadcol(s,DestFileType,SrcFile,SrcFileType,DataType,DataOligo,SrcColn,DestColn,SrcDir,DestDir);	%Function for column substitution in PDB files
	
case 4	%'PDB residues renumbering'
	DestFileType=get(findobj(mbh,'Tag','m_FileType'),'Value');	%PDB file format
	DestColn=get(findobj(oph,'Tag','o_DestColn'),'Value');	%Destination column for renumbering
	
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	
	pdbrenumres(s,DestFileType,DestColn,DestDir);	%Function for residues renumbering in PDB files
case 5	%'Property profile(s) combining',
	PlotProf=get(findobj(oph,'Tag','o_PlotProf'),'Value');	%Plot Property profiles
	PlotLand=get(findobj(oph,'Tag','o_PlotLand'),'Value');	%Plot Property landscape
	SaveProf=get(findobj(oph,'Tag','o_SaveProf'),'Value');	%Save Property profiles
	SaveLand=get(findobj(oph,'Tag','o_SaveLand'),'Value');	%Save Property landscape
	CombMode=get(findobj(oph,'Tag','o_CombMode'),'Value');	%Averaging mode
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get initial files list
	CombFileType=get(findobj(oph,'Tag','o_CombFileType'),'Value');	%Averaging boarding bins with outside as 0
	CombFile=get(findobj(oph,'Tag','o_CombFileList'),'String');	%Get combining file
	[MBinsZ,HydEn]=hydprcomb(s,PlotProf,PlotLand,SaveProf,SaveLand,CombMode,CombFileType,...
		CombFile);	%Call function calculating Property profile
case 6	%'PDB structure reorientation' - reorient structure according to selected reorientation type and criteria
	DestFileType=get(findobj(mbh,'Tag','m_FileType'),'Value');	%PDB file format
	DestColn=get(findobj(oph,'Tag','o_DestColn'),'Value');	%Destination column for reorienting
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	ReorientMode=get(findobj(oph,'Tag','o_ReorientMode'),'Value');	%Alpha-spiral reorientation mode
	PlotResult=get(findobj(oph,'Tag','o_PlotResult'),'Value');	%Plot the result of reorientation
	SelctnColn=get(findobj(oph,'Tag','o_SelctnColn'),'Value');	%Selection column - current column with selection criterion
	CritCombMode=get(findobj(oph,'Tag','o_CritCombMode'),'Value');	%Criteria combination mode - AND <1>, OR <2>, sELECTED CRITERION <3>
	CriteriaList=get(findobj(oph,'Tag','o_CriteriaList'),'String');	%List of selection criteria for each column 
	pdbreorient(s,DestFileType,DestDir,ReorientMode,PlotResult,SelctnColn,CritCombMode,CriteriaList);	%Function for molecule reorienting in PDB files
case 7 %'PDB property 3D averaging'
	DistrType=get(findobj(oph,'Tag','o_DistrType'),'Value');	%distribution type - 'Add value to every atom in the bin' <1>,'Divide value equally between the atoms in the bin' <2>,'Divide value proportionnaly between the atoms in the bin' <3>
	DataColumn=get(findobj(oph,'Tag','o_DataColumn'),'Value');	%Column with data for calculation
	DataInclude=get(findobj(oph,'Tag','o_DataInclude'),'Value');	%Select data to include into the calculation - all the data <1>*, positive <2>, negative <3>
	CritColumn=get(findobj(oph,'Tag','o_CritColumn'),'Value');	%Column with criterion for including into the calculation
	SelectCrit=get(findobj(oph,'Tag','o_SelectCrit'),'Value');	%Select surface for calculation - outside <1>*, inside <2>, all <3>
	BinWidth=eval(get(findobj(oph,'Tag','o_BinWidth'),'String'));	%Number of bins
	CoefColumn=get(findobj(oph,'Tag','o_CoefColumn'),'Value');	%Column with coefficients to multiply parameter value. By default - exposed atom area
	CoefInclude=get(findobj(oph,'Tag','o_CoefInclude'),'Value');	%
	AverNeighb=eval(['[',get(findobj(oph,'Tag','o_AverNeighb'),'String'),']']);	%Averaging among ... neighbors
	AverMode=get(findobj(oph,'Tag','o_AverMode'),'Value');	%Averaging mode
	
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list

	prop3davrg(s,DistrType,DataColumn,DataInclude,CritColumn,SelectCrit,CoefColumn,CoefInclude,...
		BinWidth,AverNeighb,AverMode);	%Call function averaging property in 3D space
case 8	%'Volumetric data creation'
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get initial files list
	FileType=get(findobj(mbh,'Tag','m_FileType'),'Value');	%initial file type {'*.pdb', '*.txt', '*.*','*.mat','*.wrl','*VRML.mat'}
	FileInfo=get(findobj(oph,'Tag','o_FileInfo'),'String');	%Get file with VDW radii data
	VDWFileType=get(findobj(oph,'Tag','o_VDWFileType'),'Value');	%Format and type of the file with data of VDW radii {'*.pdb', '*.txt column', '*.psf', '*.*'}
	OutFileType=get(findobj(oph,'Tag','o_OutFileType'),'Value');	%Format of output file with volumetric data {'*.mat','*.txt'}
	ZIPoutput=get(findobj(oph,'Tag','o_ZIPoutput'),'Value');	%Flag to pack reasonably selected oputput files into zip archives
	GridStepType=get(findobj(oph,'Tag','o_GridStepType'),'Value');	%Type of the calculation of volumetric grid steps - by the step length or number of steps {'Length, A','Steps'}
	GridStep=eval(['[',get(findobj(oph,'Tag','o_GridStep'),'String'),']']);	%Length of the grid step (in Angstroms) or number of steps in the grid
	ProbeSurfType=get(findobj(oph,'Tag','o_ProbeSurfType'),'Value');	%Is surface created by the probe center or probe surface trajectory {'No probe','Center of probe','Surface of probe'}
	PlotSurfLevel=eval(['[',get(findobj(oph,'Tag','o_PlotSurfLevel'),'String'),']']);	%Level of probability to see an atom at which plot molecular surface
	PlotSurf=get(findobj(oph,'Tag','o_PlotSurf'),'Value');	%Flag to plot molecular surface
	SmoothNeighb=get(findobj(oph,'Tag','o_SmoothNeighb'),'Value');	%Option don't smooth the data, use Gaussian smoothing of volumetric data or multiple 1-neighbor smoothing 
	SmoothNeighbRange=eval(['[',get(findobj(oph,'Tag','o_SmoothNeighbRange'),'String'),']']);	%Range of neighbor bins for Gaussian smoothing of volumetric data
	ProbeRadius=eval(['[',get(findobj(oph,'Tag','o_ProbeRadius'),'String'),']']);	%Radius of the probe to create the molecular surface
	MeanOfAllPDBs=eval(get(findobj(oph,'Tag','o_MeanOfAllPDBs'),'String'));	%Flag to average the data from every ... PDB files submitted into one volumetric matrix
	AutoMatrix=get(findobj(oph,'Tag','o_AutoMatrix'),'Value');	%Autodetect matrix size from PDB coordinates 
	XFrom=eval(get(findobj(oph,'Tag','o_XFrom'),'String'));	%Matrix beginning in X direction
	XTo=eval(get(findobj(oph,'Tag','o_XTo'),'String'));	%Matrix end in X direction
	YFrom=eval(get(findobj(oph,'Tag','o_YFrom'),'String'));	%Matrix beginning in X direction
	YTo=eval(get(findobj(oph,'Tag','o_YTo'),'String'));	%Matrix end in Y direction
	ZFrom=eval(get(findobj(oph,'Tag','o_ZFrom'),'String'));	%Matrix beginning in X direction
	ZTo=eval(get(findobj(oph,'Tag','o_ZTo'),'String'));	%Matrix end in Z direction
	VDWRadiusSource=get(findobj(oph,'Tag','o_VDWRadiusSource'),'Value');	%Source of data for assigning VDW radius for PDB atoms {'Guess VDW radii using atom names','VDW radii in the column of orig. PDB structure','VDW radii in the separate file','Zero VDW radii assigned for all the atoms'}
	DataOligo=get(findobj(oph,'Tag','o_DataOligo'),'Value');	%Data per monomer, per whole oligomer, or per atom type  in source file
	SrcColn=get(findobj(oph,'Tag','o_SrcColn'),'Value');	%Default Source column for VDW radius data - beta
	pdbmkvolm(s,FileType,FileInfo,VDWFileType,OutFileType,GridStepType,GridStep,ProbeSurfType,PlotSurfLevel,...
		PlotSurf,SmoothNeighb,SmoothNeighbRange,ProbeRadius,MeanOfAllPDBs,VDWRadiusSource,DataOligo,...
		SrcColn,SrcDir,DestDir,AutoMatrix,XFrom,XTo,YFrom,YTo,ZFrom,ZTo,ZIPoutput);	%Function co compute volumetric density data from PDB files
case 9	%'Crossection area calculation by voulmetric data'
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get initial files list
	FileType=get(findobj(mbh,'Tag','m_FileType'),'Value');	%initial file type {'*.pdb', '*.txt', '*.*','*.mat','*.wrl','*VRML.mat'}
	PlotSurf=get(findobj(oph,'Tag','o_PlotSurf'),'Value');	%Flag to plot molecular surfaces
	PlotCrosContr=get(findobj(oph,'Tag','o_PlotCrosContr'),'Value');	%Flag to plot calculated contours
	PlotCrosAreas=get(findobj(oph,'Tag','o_PlotCrosAreas'),'Value');	%Flag to plot crossections areas
	PlotCrosRadii=get(findobj(oph,'Tag','o_PlotCrosRadii'),'Value');	%Flag to plot crossections radii
	PlotCrosPerim=get(findobj(oph,'Tag','o_PlotCrosPerim'),'Value');	%Flag to plot crossections perimeter length
	PrintSurf=get(findobj(oph,'Tag','o_PrintSurf'),'Value');	%Flag to Print molecular surfaces
	PrintCrosContr=get(findobj(oph,'Tag','o_PrintCrosContr'),'Value');	%Flag to Print calculated contours
	PrintCrosAreas=get(findobj(oph,'Tag','o_PrintCrosAreas'),'Value');	%Flag to Print crossections areas
	PrintCrosRadii=get(findobj(oph,'Tag','o_PrintCrosRadii'),'Value');	%Flag to Print crossections radii
	PrintCrosPerim=get(findobj(oph,'Tag','o_PrintCrosPerim'),'Value');	%Flag to Print crossections perimeter length
	ImageSurf=get(findobj(oph,'Tag','o_ImageSurf'),'Value');	%Flag to Image molecular surfaces
	ImageCrosContr=get(findobj(oph,'Tag','o_ImageCrosContr'),'Value');	%Flag to Image calculated contours
	ImageCrosAreas=get(findobj(oph,'Tag','o_ImageCrosAreas'),'Value');	%Flag to Image crossections areas
	ImageCrosRadii=get(findobj(oph,'Tag','o_ImageCrosRadii'),'Value');	%Flag to Image crossections radii
	ImageCrosPerim=get(findobj(oph,'Tag','o_ImageCrosPerim'),'Value');	%Flag to Image crossections perimeter length
	SaveSurf=get(findobj(oph,'Tag','o_SaveSurf'),'Value');	%Flag to save in file the calculated surfaces
	SaveCrosContr=get(findobj(oph,'Tag','o_SaveCrosContr'),'Value');	%Flag to save in file the calculated crossections contours
	SaveCrosAreas=get(findobj(oph,'Tag','o_SaveCrosAreas'),'Value');	%Flag to save in file the calculated crossections areas
	SaveCrosRadii=get(findobj(oph,'Tag','o_SaveCrosRadii'),'Value');	%Flag to save in file the calculated crossections radii
	SaveCrosPerim=get(findobj(oph,'Tag','o_SaveCrosPerim'),'Value');	%Flag to save in file the calculated crossections perimeter length
	ZIPoutput=get(findobj(oph,'Tag','o_ZIPoutput'),'Value');	%Flag to pack reasonably selected oputput files into zip archives
	CrosNormalType=get(findobj(oph,'Tag','o_CrosNormalType'),'Value');	%Type of the normal to the crossection plane {'X axis','Y axis','Z axis','Custom vector'}
	CrosNormal=eval(['[',get(findobj(oph,'Tag','o_CrosNormal'),'String'),']']);	%X,Y,Z values for the custom Normal to the crossection planes
	PlotContourLevel=eval(['[',get(findobj(oph,'Tag','o_PlotContourLevel'),'String'),']']);	%Data per monomer or per whole oligomer in source file
	GridStepType=get(findobj(oph,'Tag','o_GridStepType'),'Value');	%Type of the calculation of slices grid steps - by the step length or number of steps{'Length, A','Steps'}
	GridStep=eval(['[',get(findobj(oph,'Tag','o_GridStep'),'String'),']']);	%Length of the grid step (in Angstroms) or number of steps in the grid
	SectNum=eval(['[',get(findobj(oph,'Tag','o_SectNum'),'String'),']']);	%Number of sectors in crossection contour
	CalcMethod=get(findobj(oph,'Tag','o_CalcMethod'),'Value');	%Method of the calculation of slices crossection area
	SortMethod=get(findobj(oph,'Tag','o_SortMethod'),'Value');	%Method of the sorting the contours within crossection
	VDWRadiusSource=get(findobj(oph,'Tag','o_VDWRadiusSource'),'Value');	%Source of data for assigning VDW radius for PDB atoms {'Guess VDW radii using atom names','VDW radii in the column of orig. PDB structure','VDW radii in the separate file','Zero VDW radii assigned for all the atoms'}
	VDWFileType=get(findobj(oph,'Tag','o_VDWFileType'),'Value');	%Format and type of the file with data of VDW radii {'*.pdb', '*.txt column', '*.psf', '*.*'}
	DataOligo=get(findobj(oph,'Tag','o_DataOligo'),'Value');	%Data per monomer, per whole oligomer, or per atom type  in source file
	SrcColn=get(findobj(oph,'Tag','o_SrcColn'),'Value');	%Default Source column for VDW radius data - beta
	FileInfo=get(findobj(oph,'Tag','o_FileInfo'),'String');	%Get file with VDW radii data

	volmcros(s,FileType,FileInfo,PlotSurf,PlotCrosContr,PlotCrosAreas,PlotCrosRadii,PlotCrosPerim,...
		PrintSurf,PrintCrosContr,PrintCrosAreas,PrintCrosRadii,PrintCrosPerim,...
		ImageSurf,ImageCrosContr,ImageCrosAreas,ImageCrosRadii,ImageCrosPerim,...
        SaveSurf,SaveCrosContr,SaveCrosAreas,SaveCrosRadii,SaveCrosPerim,CrosNormalType,CrosNormal,PlotContourLevel,...
		GridStepType,GridStep,SectNum,CalcMethod,SortMethod,VDWRadiusSource,VDWFileType,DataOligo,SrcColn,ZIPoutput);	%Function to create a set of crossections through volumetric density data and calculate crossections areas/radii
case 10	%'Channel conductance calculation by radius profile',
	PlotProf=get(findobj(oph,'Tag','o_PlotProf'),'Value');	%Plot Property profiles
	PlotLand=get(findobj(oph,'Tag','o_PlotLand'),'Value');	%Plot Property landscape
	PrintProf=get(findobj(oph,'Tag','o_PrintProf'),'Value');	%Print Property profiles
	PrintLand=get(findobj(oph,'Tag','o_PrintLand'),'Value');	%Print Property landscape
	ImageProf=get(findobj(oph,'Tag','o_ImageProf'),'Value');	%Image Property profiles
	ImageLand=get(findobj(oph,'Tag','o_ImageLand'),'Value');	%Image Property landscape
	SaveProf=get(findobj(oph,'Tag','o_SaveProf'),'Value');	%Save Property profiles
	SaveLand=get(findobj(oph,'Tag','o_SaveLand'),'Value');	%Save Property landscape
	CondParm=eval(['[',get(findobj(oph,'Tag','o_CondParm'),'String'),']']);	%Value of conductivity
	HydrShell=eval(['[',get(findobj(oph,'Tag','o_HydrShell'),'String'),']']);	%Value of conductivity
	CondParmType=get(findobj(oph,'Tag','o_CondParmType'),'Value');	%Type of conductivity parameter
	ProfType=get(findobj(oph,'Tag','o_ProfType'),'Value');	%Geometrical profile type - radius or area
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	
	[MBinsZ,HydEn]=condprof(s,PlotProf,PlotLand,PrintProf,PrintLand,ImageProf,ImageLand,SaveProf,SaveLand,CondParm,CondParmType,ProfType,HydrShell);	%Call function calculating channel conductance and profile of resistance
case 11	%'Volumetric data visualization'
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	CrosNormalType=get(findobj(oph,'Tag','o_CrosNormalType'),'Value');	%Type of the normal to the crossection plane
	CrosNormal=eval(['[',get(findobj(oph,'Tag','o_CrosNormal'),'String'),']']);	%X,Y,Z values for the custom Normal to the crossection planes
	CrosType=get(findobj(oph,'Tag','o_CrosType'),'Value');	%Type of the crossection cutting
	FromEdit=eval(['[0',get(findobj(oph,'Tag','o_FromEdit'),'String'),']']);	%minimal value for crossection scan range
	ToEdit=eval(['[0',get(findobj(oph,'Tag','o_ToEdit'),'String'),']']);	%maximal value for crossection scan range
	FromAuto=get(findobj(oph,'Tag','o_FromAuto'),'Value');	%Autodetect minimal value for crossection scan range
	ToAuto=get(findobj(oph,'Tag','o_ToAuto'),'Value');	%Autodetect maximal value for crossection scan range
	PlotResult=get(findobj(oph,'Tag','o_PlotResult'),'Value');	%Plot the result of the calculation
	PrintResult=get(findobj(oph,'Tag','o_PrintResult'),'Value');	%Print the result of the calculation
	ImageResult=get(findobj(oph,'Tag','o_ImageResult'),'Value');	%Image file of the result of the calculation
	SaveResult=get(findobj(oph,'Tag','o_SaveResult'),'Value');	%Save the result of the calculation
	Symmetry=round(eval(['[',get(findobj(oph,'Tag','o_Symmetry'),'String'),']']));	%Symmetry of the system to be taken into account - slice will be averaged n-fold
    AutoPlotMinMax=get(findobj(oph,'Tag','o_AutoPlotMinMax'),'Value');	%Autodetect minimal and maximal value for the plot scale and coloring
    PlotMin=eval(['[0',get(findobj(oph,'Tag','o_PlotMin'),'String'),']']);	%Set minimal value for the plot scale and coloring
    PlotMax=eval(['[0',get(findobj(oph,'Tag','o_PlotMax'),'String'),']']);	%Set maximal value for the plot scale and coloring

	%Linear crossection of the preselected slice
	MakeLinCros=get(findobj(oph,'Tag','o_MakeLinCros'),'Value');	%Make Linear crossection of the preselected slice
	CrosNormalTypeLin=get(findobj(oph,'Tag','o_CrosNormalTypeLin'),'Value');	%Type of the normal to the crossection plane
	CrosNormalLin=eval(['[',get(findobj(oph,'Tag','o_CrosNormalLin'),'String'),']']);	%X,Y,Z values for the custom Normal to the crossection planes
	CrosTypeLin=get(findobj(oph,'Tag','o_CrosTypeLin'),'Value');	%Type of the crossection cutting
	FromEditLin=eval(['[0',get(findobj(oph,'Tag','o_FromEditLin'),'String'),']']);	%minimal value for crossection scan range
	ToEditLin=eval(['[0',get(findobj(oph,'Tag','o_ToEditLin'),'String'),']']);	%maximal value for crossection scan range
	FromAutoLin=get(findobj(oph,'Tag','o_FromAutoLin'),'Value');	%Autodetect minimal value for crossection scan range
	ToAutoLin=get(findobj(oph,'Tag','o_ToAutoLin'),'Value');	%Autodetect maximal value for crossection scan range
	PlotResultLin=get(findobj(oph,'Tag','o_PlotResultLin'),'Value');	%Plot the result of the calculation
	PrintResultLin=get(findobj(oph,'Tag','o_PrintResultLin'),'Value');	%Print the result of the calculation
	ImageResultLin=get(findobj(oph,'Tag','o_ImageResultLin'),'Value');	%Image file of the result of the calculation
	SaveResultLin=get(findobj(oph,'Tag','o_SaveResultLin'),'Value');	%Save the result of the calculation
	SymmetryLin=round(eval(['[',get(findobj(oph,'Tag','o_SymmetryLin'),'String'),']']));	%Symmetry of the system to be taken into account - slice will be averaged n-fold
    AutoPlotMinMaxLin=get(findobj(oph,'Tag','o_AutoPlotMinMaxLin'),'Value');	%Autodetect minimal and maximal value for the linear plot scale and coloring
    PlotMinLin=eval(['[0',get(findobj(oph,'Tag','o_PlotMinLin'),'String'),']']);	%Set minimal value for the linear plot scale and coloring
    PlotMaxLin=eval(['[0',get(findobj(oph,'Tag','o_PlotMaxLin'),'String'),']']);	%Set maximal value for the linear plot scale and coloring

	volmvis(s,CrosNormalType,CrosNormal,CrosType,FromEdit,ToEdit,FromAuto,ToAuto,PlotResult,PrintResult,...
		ImageResult,SaveResult,Symmetry,MakeLinCros,CrosNormalTypeLin,CrosNormalLin,CrosTypeLin,FromEditLin,...
		ToEditLin,FromAutoLin,ToAutoLin,PlotResultLin,PrintResultLin,ImageResultLin,SaveResultLin,SymmetryLin,...
        AutoPlotMinMax,PlotMin,PlotMax,AutoPlotMinMaxLin,PlotMinLin,PlotMaxLin);	%Function to visualize volumetric data array
case 12	%'Volumetric data combining'
	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get file list
	CombMode=get(findobj(oph,'Tag','o_CombMode'),'Value');	%Mode of volumetric matrixes combining
	ZIPoutput=get(findobj(oph,'Tag','o_ZIPoutput'),'Value');	%Flag to pack reasonably selected oputput files into zip archives
    WeightList=get(findobj(oph,'Tag','o_WeightList'),'String');	%List of weights for each file for combining

	volmcomb(s,CombMode,WeightList,ZIPoutput);	%Function to combine and average or rescale volumetric data arrays
end

SndNp(3);


% --- Executes on button press in m_FileListGenerate.
function m_FileListGenerate_Callback(hObject, eventdata, handles)   
% hObject    handle to m_FileListGenerate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Function to cgeate a filelist from the filename numbering pattern

global mbh
FileName=get(findobj(mbh,'Tag','m_FileInfo'),'String');
PatternFrom=eval(['0',get(findobj(mbh,'Tag','m_PatternFrom'),'String')]);
PatternTo=eval(['0',get(findobj(mbh,'Tag','m_PatternTo'),'String')]);

NumbersPosition=findstr(FileName,'#');
if isempty(NumbersPosition)
    NumbersPosition=length(FileName)+1;
end

NumbersPosition=[min(NumbersPosition) max(NumbersPosition)];
if NumbersPosition(1)==1
    FileNamePrefix='';
else
    FileNamePrefix=FileName(1:(NumbersPosition(1)-1));
end
if NumbersPosition(2)>=length(FileName)
    FileNameSuffix='';
else
    FileNameSuffix=FileName((NumbersPosition(2)+1):end);
end

Numbers=max([(NumbersPosition(2)-NumbersPosition(1)+1),length(num2str(PatternFrom)),length(num2str(PatternTo))]);
Number=PatternFrom:PatternTo;
Format=['%0',num2str(Numbers),'i'];
for n=1:length(Number);
    s{n}=[FileNamePrefix,sprintf(Format,Number(n)),FileNameSuffix];
end

set(findobj(mbh,'Tag','m_FileList'),'Value',1);
set(findobj(mbh,'Tag','m_FileList'),'String',s);
set(findobj(mbh,'Tag','m_FileInfo'),'String',s{1});


% --- Executes during object creation, after setting all properties.
function m_PatternFrom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_PatternFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function m_PatternFrom_Callback(hObject, eventdata, handles)
% hObject    handle to m_PatternFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of m_PatternFrom as text
%        str2double(get(hObject,'String')) returns contents of m_PatternFrom as a double


% --- Executes during object creation, after setting all properties.
function m_PatternTo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_PatternTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function m_PatternTo_Callback(hObject, eventdata, handles)
% hObject    handle to m_PatternTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of m_PatternTo as text
%        str2double(get(hObject,'String')) returns contents of m_PatternTo as a double


% --- Executes on button press in m_FileListGenerateLoad.
function m_FileListGenerateLoad_Callback(hObject, eventdata, handles)

% hObject    handle to m_FileListGenerateLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global mbh SrcDir DestDir
FileName=get(findobj(mbh,'Tag','m_FileInfo'),'String');
s=[];
ft='*.txt';
[s,v]=uigetfiles(ft,'Select a numbers list file:');
if ~isempty(s)
    cd(v);
    Number=load(s{1},'ASCII');
    
    NumbersPosition=findstr(FileName,'#');
    if isempty(NumbersPosition)
        NumbersPosition=length(FileName)+1;
    end
    
    NumbersPosition=[min(NumbersPosition) max(NumbersPosition)];
    if NumbersPosition(1)==1
        FileNamePrefix='';
    else
        FileNamePrefix=FileName(1:(NumbersPosition(1)-1));
    end
    if NumbersPosition(2)>=length(FileName)
        FileNameSuffix='';
    else
        FileNameSuffix=FileName((NumbersPosition(2)+1):end);
    end
    
    Numbers=max([(NumbersPosition(2)-NumbersPosition(1)+1),length(num2str(max(Number))),length(num2str(min(Number)))]);
    Format=['%0',num2str(Numbers),'i'];
    for n=1:length(Number);
        s{n}=[FileNamePrefix,sprintf(Format,Number(n)),FileNameSuffix];
    end
    
    set(findobj(mbh,'Tag','m_FileList'),'Value',1);
    set(findobj(mbh,'Tag','m_FileList'),'String',s);
    set(findobj(mbh,'Tag','m_FileInfo'),'String',s{1});
end


