function varargout = o_pdbmkvolm(varargin)
% O_pdbmkvolm Application M-file for o_pdbmkvolm.fig
%    FIG = O_pdbmkvolm launch o_pdbmkvolm GUI.
%    O_pdbmkvolm('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 25-Feb-2005 21:34:02

global mbh oph SrcDir DestDir


if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');


	% Generate a structure of handles to pass to callbacks, and store it. 
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.
%mb('o_DestColn_Callback',gcbo,[],guidata(gcbo))


% --------------------------------------------------------------------
function varargout = o_DataType_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_DataType.


% --------------------------------------------------------------------
function varargout = o_FileListLoad_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_FileListLoad.
global oph SrcDir DestDir
FileType=get(findobj(oph,'Tag','o_VDWFileType'),'Value');
s=[];
switch FileType
case 1	%PDB
    ft='*.pdb';
case 2	%TXT column
    ft='*.txt';
case 3	%PSF
    ft='*.psf';
otherwise
    ft='*.*';
end
[s,v]=uigetfiles(ft,'Select a data file:');
 SrcDir=v;
if ~isempty(s)
    cd(v);
    set(findobj(oph,'Tag','o_FileInfo'),'String',s{1});
%     set(findobj(oph,'Tag','m_FileList'),'Value',1);
%     set(findobj(oph,'Tag','m_FileList'),'String',s);
end

% --------------------------------------------------------------------
function varargout = o_FileType_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_FileType.


% --------------------------------------------------------------------
function varargout = o_DataOligo_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_DataOligo.


% --------------------------------------------------------------------
function varargout = o_SrcColn_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_SrcColn.


% --------------------------------------------------------------------
function varargout = o_DestColn_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_DestColn.



% --------------------------------------------------------------------
function varargout = o_OutFileType_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_OutFileType.



% --------------------------------------------------------------------
function varargout = o_VDWRadiusSource_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_VDWRadiusSource.



% --------------------------------------------------------------------
function varargout = o_PlotSurf_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_PlotSurf.
%disp('o_PlotSurf Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = o_SmoothNeighb_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_SmoothNeighb.


% --------------------------------------------------------------------
function varargout = o_AutoMatrix_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_AutoMatrix.


% --------------------------------------------------------------------
function varargout = o_XFrom_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_XFrom.


% --------------------------------------------------------------------
function varargout = o_XTo_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_XTo.


% --------------------------------------------------------------------
function varargout = o_YFrom_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_YFrom.


% --------------------------------------------------------------------
function varargout = o_YTo_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_YTo.


% --------------------------------------------------------------------
function varargout = o_ZFrom_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_ZFrom.


% --------------------------------------------------------------------
function varargout = o_ZTo_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_ZTo.


% --- Executes on button press in o_ZIPoutput.
function o_ZIPoutput_Callback(hObject, eventdata, handles)
% hObject    handle to o_ZIPoutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of o_ZIPoutput


