function varargout = o_pdbreorient(varargin)
% O_PDBADCOL Application M-file for o_pdbadcol.fig
%    FIG = O_PDBADCOL launch o_pdbadcol GUI.
%    O_PDBADCOL('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 15-Apr-2002 22:21:08
global mbh oph SrcDir DestDir


if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

    % Use system color scheme for figure:
    set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.
%mb('o_DestColn_Callback',gcbo,[],guidata(gcbo))


% --------------------------------------------------------------------
function varargout = o_SelctnColn_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_DataType.
global mbh oph SrcDir DestDir

CriteriaListPos=get(findobj(oph,'Tag','o_SelctnColn'),'Value');	%Selection column - index
CriteriaList=get(findobj(oph,'Tag','o_CriteriaList'),'String');
set(findobj(oph,'Tag','o_CriteriaList'),'Value',CriteriaListPos);
set(findobj(oph,'Tag','o_SelctnCrit'),'String',CriteriaList{CriteriaListPos});



% --------------------------------------------------------------------
function varargout = o_SelctnCrit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_SelctnCrit.
%disp('o_SelctnCrit Callback not implemented yet.')
global mbh oph SrcDir DestDir

CriteriaListPos=get(findobj(oph,'Tag','o_CriteriaList'),'Value');
CriteriaList=get(findobj(oph,'Tag','o_CriteriaList'),'String');
SelctnCrit=get(findobj(oph,'Tag','o_SelctnCrit'),'String');
CriteriaList{CriteriaListPos}=SelctnCrit;
set(findobj(oph,'Tag','o_CriteriaList'),'String',CriteriaList);



% --------------------------------------------------------------------
function varargout = o_ReorientMode_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_ReorientMode.
%disp('o_ReorientMode Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = o_CritCombMode_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_CritCombMode.
%disp('o_CritCombMode Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = o_CriteriaList_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_CriteriaList.
global mbh oph SrcDir DestDir

CriteriaListPos=get(findobj(oph,'Tag','o_CriteriaList'),'Value');
CriteriaList=get(findobj(oph,'Tag','o_CriteriaList'),'String');
set(findobj(oph,'Tag','o_SelctnColn'),'Value',CriteriaListPos);	%Selection column - index
set(findobj(oph,'Tag','o_SelctnCrit'),'String',CriteriaList{CriteriaListPos});

	
