function varargout = o_prop3davrg(varargin)
% O_HYDROPROF Application M-file for o_hydroprof.fig
%    FIG = O_HYDROPROF launch o_hydroprof GUI.
%    O_HYDROPROF('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 28-Apr-2002 12:32:49

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

    % Use system color scheme for figure:
    set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = o_PlotProf_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_PlotProf.


% --------------------------------------------------------------------
function varargout = o_PlotLand_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_PlotLand.


% --------------------------------------------------------------------
function varargout = o_SaveProf_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_SaveProf.


% --------------------------------------------------------------------
function varargout = o_SaveLand_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_SaveLand.



% --------------------------------------------------------------------
function varargout = o_SelectCrit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_SelectCrit.
%disp('o_SelectCrit Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = o_DataInclude_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_DataInclude.
%disp('o_DataInclude Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = o_ProfileGeom_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_ProfileGeom.
%disp('o_ProfileGeom Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = o_BinsNum_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_BinsNum.
%disp('o_BinsNum Callback not implemented yet.')

% --------------------------------------------------------------------
function varargout = o_AverMode_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.o_AverMode.
%0.16 0.15 0.12 0.08 0.04 0.02 0.01
global oph
switch get(findobj(oph,'Tag','o_AverMode'),'Value')	%Averaging mode
case 1	%'Mean of ... neighbors'
	set(findobj(oph,'Tag','o_AverNeighb'),'String','1');	%Averaging among ... neighbors
case 2	%'A-shaped mean of ... neighbors'
	set(findobj(oph,'Tag','o_AverNeighb'),'String','2');	%Averaging among ... neighbors
case 3	%'Profile of neighbor bins with coefficients ... (from center to edge)'
	set(findobj(oph,'Tag','o_AverNeighb'),'String','0.16 0.15 0.12 0.08 0.04 0.02 0.01');	%Averaging among ... neighbors
case 4	%'Normal distribution with standard deviation of ... A'
	set(findobj(oph,'Tag','o_AverNeighb'),'String','2');	%Averaging among ... neighbors
end
