function 	pdbmkvolm(s,FileType,FileInfo,VDWFileType,OutFileType,GridStepType,GridStep,ProbeSurfType,...
	PlotSurfLevel,PlotSurf,SmoothNeighb,SmoothNeighbRange,ProbeRadius,MeanOfAllPDBs,VDWRadiusSource,...
	DataOligo,SrcColn,SrcDir,DestDir,AutoMatrix,XFrom,XTo,YFrom,YTo,ZFrom,ZTo,ZIPoutput);	%Function co compute volumetric density data from PDB files

%INPUTS:
% 	s=get(findobj(mbh,'Tag','m_FileList'),'String');	%Get initial files list
%	FileType=get(findobj(mbh,'Tag','m_FileType'),'Value');	%initial file type {'*.pdb', '*.txt', '*.*','*.mat','*.wrl'}
% 	VDWFileType=get(findobj(oph,'Tag','o_VDWFileType'),'Value');	%Format and type of the file with data of VDW radii {'*.pdb', '*.txt column', '*.psf', '*.*'}
% 	OutFileType=get(findobj(oph,'Tag','o_OutFileType'),'Value');	%Format of output file with volumetric data {'*.mat','*.txt'}
% 	GridStepType=get(findobj(oph,'Tag','o_GridStepType'),'Value');	%Type of the calculation of volumetric grid steps - by the step length or number of steps {'Length, A','Steps'}
% 	GridStep=eval(['[',get(findobj(oph,'Tag','o_GridStep'),'String'),']']);	%Length of the grid step (in Angstroms) or number of steps in the grid
% 	ProbeSurfType=get(findobj(oph,'Tag','o_ProbeSurfType'),'Value');	%Is surface created by the probe center or probe surface trajectory {'No probe','Center of probe','Surface of probe'}
% 	PlotSurfLevel=eval(['[',get(findobj(oph,'Tag','o_PlotSurfLevel'),'String'),']']);	%Level of probability to see an atom at which plot molecular surface
% 	PlotSurf=get(findobj(oph,'Tag','o_PlotSurf'),'Value');	%Flag to plot molecular surface
% 	SmoothNeighb=get(findobj(oph,'Tag','o_SmoothNeighb'),'Value');		%Option don't smooth the data, use Gaussian smoothing of volumetric data or multiple 1-neighbor smoothing 
% 	SmoothNeighbRange=eval(['[',get(findobj(oph,'Tag','o_SmoothNeighbRange'),'String'),']']);	%Range of neighbor bins for Gaussian smoothing of volumetric data
% 	ProbeRadius=eval(['[',get(findobj(oph,'Tag','o_ProbeRadius'),'String'),']']);	%Radius of the probe to create the molecular surface
% 	MeanOfAllPDBs=get(findobj(oph,'Tag','o_MeanOfAllPDBs'),'Value');	%Flag to average the data from every ... PDB files submitted into one volumetric matrix
% 	VDWRadiusSource=get(findobj(oph,'Tag','o_VDWRadiusSource'),'Value');	%Source of data for assigning VDW radius for PDB atoms {'Guess VDW radii using atom names','VDW radii in the column of orig. PDB structure','VDW radii in the separate file','Zero VDW radii assigned for all the atoms'}
% 	DataOligo=get(findobj(oph,'Tag','o_DataOligo'),'Value');	%Data per monomer, per whole oligomer, or per atom type  in source file
% 	SrcColn=get(findobj(oph,'Tag','o_SrcColn'),'Value');	%Default Source column for VDW radius data - beta
%	SrcDir	- Directory with VDW radii data file
%	DestDir	- Directory with ATOM or VRML coordinates data file were output files with volumetric data will be saved
%	AutoMatrix=get(findobj(oph,'Tag','o_AutoMatrix'),'Value'));	%Autodetect matrix size from PDB coordinates 
%	XFrom=eval(get(findobj(oph,'Tag','o_XFrom'),'String'));	%Matrix beginning in X direction
%	XTo=eval(get(findobj(oph,'Tag','o_XTo'),'String'));	%Matrix end in X direction
%	YFrom=eval(get(findobj(oph,'Tag','o_YFrom'),'String'));	%Matrix beginning in X direction
%	YTo=eval(get(findobj(oph,'Tag','o_YTo'),'String'));	%Matrix end in Y direction
%	ZFrom=eval(get(findobj(oph,'Tag','o_ZFrom'),'String'));	%Matrix beginning in X direction
%	ZTo=eval(get(findobj(oph,'Tag','o_ZTo'),'String'));	%Matrix end in Z direction

%Output
%

global ATOM


dbstop if error

if ~isempty(s)
    initial_time=now;
	if MeanOfAllPDBs<=0|MeanOfAllPDBs>length(s); MeanOfAllPDBs=length(s); end;	%If wrong number of files for averaging was selected, it will be corrected to the total number of files 
	ProgressBarGlobal(0,length(s));%Set current value on the global progress bar
	ProgressBarLocal(0,100);%Set current value on the global progress bar
	ATOM0=[];
	%============ATOM array initialization
	ATOM0.line=[];	%Number of the line in PDB file
	ATOM0.index=[];	%        Atom serial number.
	ATOM0.name={};	%          Atom name.
	ATOM0.altloc={};	%        Alternate location indicator.
	ATOM0.resname={};	%       Residue name.
	ATOM0.chain={};	%       Chain identifier.
	ATOM0.resid=[];	%        Residue sequence number.
	ATOM0.icode={};	%         Code for insertion of residues.
	ATOM0.x=[];	%             Orthogonal coordinates for X in Angstroms.
	ATOM0.y=[];	%             Orthogonal coordinates for Y in Angstroms.
	ATOM0.z=[];	%             Orthogonal coordinates for Z in Angstroms.
	ATOM0.occupancy=[];	%     Occupancy.
	ATOM0.beta=[];	%    Temperature factor.
	ATOM0.segname={};	%         Segment identifier, left-justified.
	ATOM0.element={};	%       Element symbol, right-justified.
	ATOM0.charge={};	%        Charge on the atom.
	ATOM0.pdb=[];	%content of the PDB file
	
	%     Fields(1)=0;%        Atom serial number.
	%     Fields(2)=0; %          Atom name.
	%     Fields(3)=0; %        Alternate location indicator.
	%     Fields(4)=0; %       Residue name.
	%     Fields(5)=0; %       Chain identifier.
	%     Fields(6)=0; %        Residue sequence number.
	%     Fields(7)=0; %         Code for insertion of residues.
	%     Fields(8)=0; %             Orthogonal coordinates for X in Angstroms.
	%     Fields(9)=0; %             Orthogonal coordinates for Y in Angstroms.
	%     Fields(10)=1; %             Orthogonal coordinates for Z in Angstroms.
	%     Fields(11)=1; %     Occupancy.
	%     Fields(12)=1; %    Temperature factor.
	%     Fields(13)=0; %         Segment identifier, left-justified.
	%     Fields(14)=0; %       Element symbol, right-justified.
	%     Fields(15)=0; %        Charge on the atom.
	Fields=ones(1,15);    
	FinalVolmData=[];
	DefaultRadius=1.5;	%Default atom VDW radius for unrecognized atom types, if necessary
	
	
	%Read VDW radii data if they are in the separate file
	switch VDWRadiusSource	%Source of data for assigning VDW radius for PDB atoms
	case 1	%'Guess VDW radii using atom names',...
	case 2	%'VDW radii in the column of orig. PDB structure'
	case 3	%'VDW radii in the separate file'
		cd(SrcDir)
		switch VDWFileType	%Format and type of the file with data of VDW radii
		case 1	%'*.pdb'
			ATOMSrc=ATOM0;
			ATOMSrc=readPDBfull(SrcFile,Fields,1);	%=================Reads PDB structure file into structure array
			ProgressBarFile(m);
			disp(['VDW radii. ',SrcFile,':      ',num2str(length(ATOMSrc.line)), '-atoms structure read']);
			
			switch SrcColn	%Select column in ATOMSrc to read insert data
				% 	switch DestColn	%Select column in ATOMSrc to read insert data
			case 1
				VDWperAtom=ATOMSrc.index;	%        Atom serial number.
			case 2
				VDWperAtom=ATOMSrc.name;	%          Atom name.
			case 3
				VDWperAtom=ATOMSrc.altloc;	%        Alternate location indicator.
			case 4
				VDWperAtom=ATOMSrc.resname;	%       Residue name.
			case 5
				VDWperAtom=ATOMSrc.chain;	%       Chain identifier.
			case 6
				VDWperAtom=ATOMSrc.resid;	%        Residue sequence number.
			case 7
				VDWperAtom=ATOMSrc.icode;	%         Code for insertion of residues.
			case 8
				VDWperAtom=ATOMSrc.x;	%             Orthogonal coordinates for X in Angstroms.
			case 9
				VDWperAtom=ATOMSrc.y;	%             Orthogonal coordinates for Y in Angstroms.
			case 10
				VDWperAtom=ATOMSrc.z;	%             Orthogonal coordinates for Z in Angstroms.
			case 11
				VDWperAtom=ATOMSrc.occupancy;	%     Occupancy.
			case 12
				VDWperAtom=ATOMSrc.beta;	%    Temperature factor.
			case 13
				VDWperAtom=ATOMSrc.segname;	%         Segment identifier, left-justified.
			case 14
				VDWperAtom=ATOMSrc.element;	%       Element symbol, right-justified.
			case 15
				VDWperAtom=ATOMSrc.charge;	%        Charge on the atom.
			end
			DataOligo=2;	%Data per oligomer
			ATOMSrc=[];
		case 2	%'*.txt column'
			switch DataOligo	%Data per monomer, per whole oligomer, or per atom type  in source file
			case {1 2}	%Data per monomer 	%Data per whole oligomer
				DataIns=load(SrcFile, '-ascii')';
			case 3	%Data per atom type  in source file
% 				vh = fopen(FileInfo);
% 				[VDWperType.name VDWperType.radius] = fscanf(vh,'%s %s',[2 inf]) % It has two rows now.
% 				fclose(vh)
				file = textread(FileInfo,'%s','delimiter','\t','whitespace','');
				file=reshape(file,[2,length(file)/2]);
				VDWperType.name={file{1,:}};
				VDWperType.radius=[];
				for i=1:length(file)
					VDWperType.radius(i)=eval(file{2,i});
				end
				disp(['VDW radii data (per atom type): ',FileInfo,':      ',num2str(length(VDWperType.name)),...
						'-(atom types) file read']);
			end	%Data per monomer, per whole oligomer, or per atom type  in source file
		case 3	%'*.psf'
			disp('not implemented yet');
			return
			DataOligo=2;	%Data per oligomer
		case 4	%'*.*'});
			VDWperAtom=load(FileInfo, '-ascii')';
		end
	case 4	%'Zero VDW radii assigned for all the atoms'});
			DataOligo=2;	%Data per oligomer
	end
	
	VDWperAtomProcessed=0;	%Flag for processed list VDW radii per atom (from data per monomer)
	
	mSet=1;	%The first file in the current set for averaging
	for m=1:length(s)
		ProgressBarFile(m)
		cd(DestDir)
		ATOM=[];
		VolmData=[];
		ATOM=ATOM0;	%Initializing ATOM array
		
		%=================Reading structure data from the file
		switch FileType	%initial file type {'*.pdb', '*.txt', '*.*','*.mat','*.wrl'}
		case 1	%PDB
			ATOM=readPDBfull(s{m},Fields,1);	%=================Reads PDB structure file into structure array
			if VDWRadiusSource==2	%'VDW radii in the column of orig. PDB structure'
				switch SrcColn	%Select column in ATOMSrc to read insert data
					% 	switch DestColn	%Select column in ATOMSrc to read insert data
				case 1
					VDWperAtom=ATOM.index;	%        Atom serial number.
				case 2
					VDWperAtom=ATOM.name;	%          Atom name.
				case 3
					VDWperAtom=ATOM.altloc;	%        Alternate location indicator.
				case 4
					VDWperAtom=ATOM.resname;	%       Residue name.
				case 5
					VDWperAtom=ATOM.chain;	%       Chain identifier.
				case 6
					VDWperAtom=ATOM.resid;	%        Residue sequence number.
				case 7
					VDWperAtom=ATOM.icode;	%         Code for insertion of residues.
				case 8
					VDWperAtom=ATOM.x;	%             Orthogonal coordinates for X in Angstroms.
				case 9
					VDWperAtom=ATOM.y;	%             Orthogonal coordinates for Y in Angstroms.
				case 10
					VDWperAtom=ATOM.z;	%             Orthogonal coordinates for Z in Angstroms.
				case 11
					VDWperAtom=ATOM.occupancy;	%     Occupancy.
				case 12
					VDWperAtom=ATOM.beta;	%    Temperature factor.
				case 13
					VDWperAtom=ATOM.segname;	%         Segment identifier, left-justified.
				case 14
					VDWperAtom=ATOM.element;	%       Element symbol, right-justified.
				case 15
					VDWperAtom=ATOM.charge;	%        Charge on the atom.
				end	%Select column in ATOMSrc to read insert data
				DataOligo=2;	%Data per oligomer
			end	%'VDW radii in the column of orig. PDB structure'
        case 2  %txt - text file with x,y,z coordinates in 3 columns separated by tabs
            TempZipFileName=unzip_AGA(s{m});  %Temporary Unzip file, if necesary
            POINT=load(s{m});	%Read VRML file into structural array with fields .Coordinate3 and .IndexedFaceSet
            unzip_AGA(s{m},TempZipFileName);  %Remove Temporary Unzip file, if necesary
			ATOM.x=POINT(:,1)';	%Transform VRML vertices to ATOMs
			ATOM.y=POINT(:,2)';	%Transform VRML vertices to ATOMs
			ATOM.z=POINT(:,3)';	%Transform VRML vertices to ATOMs
			clear POINT;
			VDWRadiusSource=4;	%'Zero VDW radii assigned for all the atoms'});
			DataOligo=2;	%Data per oligomer
		case 5	%'*.wrl VRML file'
            TempZipFileName=unzip_AGA(s{m});  %Temporary Unzip file, if necesary
            POINT=load(s{m});	%Read VRML file into structural array with fields .Coordinate3 and .IndexedFaceSet
            unzip_AGA(s{m},TempZipFileName);  %Remove Temporary Unzip file, if necesary
			POINT=readVRMLfull(s{m});	%Read VRML file into structural array with fields .Coordinate3 and .IndexedFaceSet
			ATOM.x=POINT.Coordinate3(1,:);	%Transform VRML vertices to ATOMs
			ATOM.y=POINT.Coordinate3(2,:);	%Transform VRML vertices to ATOMs
			ATOM.z=POINT.Coordinate3(3,:);	%Transform VRML vertices to ATOMs
			clear POINT;
			VDWRadiusSource=4;	%'Zero VDW radii assigned for all the atoms'});
			DataOligo=2;	%Data per oligomer
		otherwise
			disp('Wrong initial structure file type');
			return
		end	%initial file type {'*.pdb', '*.txt', '*.*','*.mat','*.wrl'}
		ProgressBarGlobal((m-1+0.1),length(s));%Set current value on the global progress bar

		
		%Transform VDW radii data from monomer to oligomer or find radius for every atom from data per atom type
		switch DataOligo	%Data per monomer, per whole oligomer, or per atom type  in source file
		case 1	%Data per monomer 
			%Transform VDW radii data from monomer to oligomer
			if ~VDWperAtomProcessed&DataOligo==1&FileType==1	%This is the first PDB in the set, and VDW radii are per monomer atom, and coordinates are in PDB file
				%--- calculate monomer length	- supposing that all monomers are of the same length
				FirsrResid=min(ATOM.resid);
				LastResid=max(ATOM.resid);
				% 		Monomer=LastResid-FirsrResid+1;	%number of residues in monomer
				OligoRes=1;	%All the residues in oligomer
				FirstAtoms=1;	%1st monomer begins
				for i=2:length(ATOM.resid)
					if ATOM.resid(i-1)>ATOM.resid(i)	%New monomer begins
						FirstAtoms(end+1)=i;
					end
					
					if ATOM.resid(i-1)~=ATOM.resid(i)	%New residue begins
						OligoRes(end+1)=i;
					end
				end
				Oligo=length(FirstAtoms);	%number of monomers in oligomer
				if Oligo>1	%Oligomer
					MonomerAtoms=FirstAtoms(2)-FirstAtoms(1);	%number of atoms in monomer
					Monomer=min(find(OligoRes==FirstAtoms(2)))-1;%number of residues in monomer
				else	%monomer
					MonomerAtoms=ATOM.index(end)-ATOM.index(1)+1;	%number of atoms in monomer
					Monomer=length(OligoRes);%number of residues in monomer
				end
				
				for i=2:Oligo	%other monomers
					VDWperAtom=[VDWperAtom,VDWperAtom(1:MonomerAtoms)];	%Duplicating data
				end
				VDWperAtomProcessed=1;
			end
		case 2	%Data per whole oligomer
			%VDWperAtom was already formed or will be formed
		case 3	%Data per atom type  in source file
			for i=1:length(ATOM.x)
				NameIndex = strmatch(ATOM.name(i),VDWperType.name,'exact'); %Find name of current atom in the loaded database of atom names
				if	isempty(NameIndex)	%atom type unrecognized
					VDWperAtom(i)=DefaultRadius;
				else
					NameIndex=NameIndex(1);	%first radius for the case of several coincedences
					VDWperAtom(i)=VDWperType.radius(NameIndex);
				end
			end
		end	%Data per monomer, per whole oligomer, or per atom type  in source file
		
		
		
		%------------------ calculate the volumetric data
		%-------- Initial atom positions, VDW radii
		switch VDWRadiusSource	%Source of data for assigning VDW radius for PDB atoms
		case 1	%'Guess VDW radii using atom names',...
			disp('Not implemented yet');
			return
		case 2	%'VDW radii in the column of orig. PDB structure'
			%VDWperAtom was already formed
		case 3	%'VDW radii in the separate file'
			%VDWperAtom was already formed
		case 4	%'Zero VDW radii assigned for all the atoms'});
			VDWperAtom=zeros(size(ATOM.x));
		end	%Source of data for assigning VDW radius for PDB atoms
		
		%-------- Add solvent radius to the atom radii, if necessary
		if ProbeSurfType==2|ProbeSurfType==3	%Solvent is used
			VDWperAtom=VDWperAtom+ProbeRadius;
		end
		
		%-------- Calculate volumetric data from the given Atom coordinates and radii
		if ~(MeanOfAllPDBs>1&m>1) %not (averaging among all the input structure files, and this is not the first file)
			if AutoMatrix==1	%Autodetect matrix size from PDB coordinates
				XFrom=min(ATOM.x);	%Matrix beginning in X direction
				XTo=max(ATOM.x);	%Matrix end in X direction
				YFrom=min(ATOM.y);	%Matrix beginning in X direction
				YTo=max(ATOM.y);	%Matrix end in Y direction
				ZFrom=min(ATOM.z);	%Matrix beginning in X direction
				ZTo=max(ATOM.z);	%Matrix end in Z direction
				
			else	%custom matrix size from PDB coordinates
			end	%Autodetect matrix size from PDB coordinates
			

			%GridStepType,GridStep,SmoothNeighb,SmoothNeighbRange
			%--- steps of greed
			switch GridStepType	%Type of the calculation of volumetric grid steps - by the step length or number of steps {'Length, A','Steps'}
			case 1	%Length, A
				StepX=GridStep;
				StepY=GridStep;
				StepZ=GridStep;
			case 2	%# of steps	- it is considered that this number of steps should be done  in the maximal range of coordinates
				MaxRange=max([(XTo-XFrom),(YTo-YFrom),(ZTo-ZFrom)]);
				StepX=MaxRange/GridStep;
				StepY=StepX;
				StepZ=StepX;
			end	%Type of the calculation of volumetric grid steps - by the step length or number of steps {'Length, A','Steps'}
			
			switch SmoothNeighb		%Option don't smooth the data, use Gaussian smoothing of volumetric data or multiple 1-neighbor smoothing 
			case 1	%don't smooth the data,
				SmoothNeighbRange=0;	%SmoothNeighbRangeing in Angstroms
				SmoothNeighbRange_box=1;
			case 2	%Gaussian smoothing
				SmoothNeighbRange_greed=SmoothNeighbRange/mean([StepX StepY StepZ]);	%size of SmoothNeighbRangeing in number of bins
				SmoothNeighbRange_box=4*round(SmoothNeighbRange_greed*1.3)+1;
			case 3	%multiple 1-neighbor smoothing 
				SmoothNeighbRange=round(SmoothNeighbRange);	%Number of 3-box smoothing cycles
				SmoothNeighbRange_box=2*SmoothNeighbRange+1;
			end
			
			%--- calculate ATOM coordinates range (after SmoothNeighbRangeing)
			ExtraSpace=4;
			if ProbeSurfType~=1	%Probe is used
				ExtraSpace=ExtraSpace+1.5*ProbeRadius/min([StepX StepY StepZ]);
			end
			MinXr=XFrom-(SmoothNeighbRange_box/2+ExtraSpace)*StepX; MaxXr=XTo+(SmoothNeighbRange_box/2+ExtraSpace)*StepX;
			MinYr=YFrom-(SmoothNeighbRange_box/2+ExtraSpace)*StepY; MaxYr=YTo+(SmoothNeighbRange_box/2+ExtraSpace)*StepY;
			MinZr=ZFrom-(SmoothNeighbRange_box/2+ExtraSpace)*StepZ; MaxZr=ZTo+(SmoothNeighbRange_box/2+ExtraSpace)*StepZ;
			
			%--- calculate coordinates of greed centers
			vMBinsX=MinXr:StepX:MaxXr;
			vMBinsY=MinYr:StepY:MaxYr;
			vMBinsZ=MinZr:StepZ:MaxZr;
			
			%--- calculate volumetric greed size
			size_x=length(vMBinsX);
			size_y=length(vMBinsY);
			size_z=length(vMBinsZ);
		end %not (averaging among all the input structure files, and this is not the first file in a set)
		
		VolmData=zeros(size_x,size_y,size_z);
		
		
		if VDWRadiusSource==4	%zero radii - add probabilities together
            SuperpositionMode='Add';	%Atoms' densities will be added to the volume
			BorderType='Single';	%Border of the atom VDW volume in the range between two mesh bins on the border
		else
            SuperpositionMode='AddMax';	%Atoms' densities will be added to the volume
			BorderType='Linear';	%Border of the atom VDW volume in the range between two mesh bins on the border
% 			BorderType='Single';	%Border of the atom VDW volume in the range between two mesh bins on the border
%			BorderType='Sharp';	%Border of the atom VDW volume in the range between two mesh bins on the border
		end

		ProgressBarGlobal((m-1+0.2),length(s));%Set current value on the global progress bar
		VolmData=xyzVDW2volm(VolmData,ATOM.x,ATOM.y,ATOM.z,VDWperAtom,...
			vMBinsX,vMBinsY,vMBinsZ,BorderType,SuperpositionMode);	%Add VDW spheres of density 1 at atoms' positions to the empty volume
		ProgressBarGlobal((m-1+0.4),length(s));%Set current value on the global progress bar
		
% 		figure;%!!!
% 		surf(VolmData(:,:,round(length(vMBinsZ)/2)));%!!!
		
		%-------- Create solvent surface
		if ProbeSurfType==3	%molecule surface determined by the sovent surface

			%put solvent molecules on the molecule boundaries and Remove atom density from solvent atom positions
			ProbeCenters=isosurface(permute(VolmData,[2 1 3]),.5);	%Mesh vertices vill be taken as new atom positions to pode probe here
			%%NOTE: X AND Y AXES ARE SWIPED TO COMPENSATE "isosurface" INTERNAL SWAP BEFORE
			%[ProbeCenters.vertices(:,1),ProbeCenters.vertices(:,2)]=swap(ProbeCenters.vertices(:,1),ProbeCenters.vertices(:,2));
			
			%!!!!!!!
					%-------- Visualize surface
% 		if PlotSurf==1	%Visualize surface
% %			ProbeCenters.vertices(ProbeCenters.vertices(:,1)>size(VolmData,1)/1.7,:)=[];
% 			%ProbeCenters.vertices(round(length(ProbeCenters.vertices)/10):end,:)=[];
% 			figure
% 			Surface=isosurface(VolmData,0.5);
% 			%Convert surface coordinates from volumetric data to their real values
% 			vMinX=min(vMBinsX); vMaxX=max(vMBinsX);
% 			vMinY=min(vMBinsY); vMaxY=max(vMBinsY);
% 			vMinZ=min(vMBinsZ); vMaxZ=max(vMBinsZ);
% 			Ax=(vMaxX-vMinX)/(size(VolmData,1)-1); Bx=vMinX-Ax;
% 			Ay=(vMaxY-vMinY)/(size(VolmData,2)-1); By=vMinY-Ay;
% 			Az=(vMaxZ-vMinZ)/(size(VolmData,3)-1); Bz=vMinZ-Az;
% 			Surface.vertices(:,1)=Ax*Surface.vertices(:,1)+Bx;
% 			Surface.vertices(:,2)=Ay*Surface.vertices(:,2)+By;
% 			Surface.vertices(:,3)=Az*Surface.vertices(:,3)+Bz;
% 			p = patch(Surface);
% 			set(p,'FaceColor',[0.8 1 1],'EdgeColor','black');
% 			daspect([1 1 1]); view(3); axis tight; camlight; lighting gouraud
% 			title(['Surface of the ',s{m},' at the p=',num2str(PlotSurfLevel),' level']);
% 			xlabel('X, A'); ylabel('Y, A'); zlabel('Z, A');
% 			
% 		end	%Visualize surface

			%Convert surface coordinates from volumetric data to their real values
			vMinX=min(vMBinsX); vMaxX=max(vMBinsX);
			vMinY=min(vMBinsY); vMaxY=max(vMBinsY);
			vMinZ=min(vMBinsZ); vMaxZ=max(vMBinsZ);
			Ax=(vMaxX-vMinX)/(size(VolmData,1)-1); Bx=vMinX-Ax;
			Ay=(vMaxY-vMinY)/(size(VolmData,2)-1); By=vMinY-Ay;
			Az=(vMaxZ-vMinZ)/(size(VolmData,3)-1); Bz=vMinZ-Az;
			ProbeCenters.vertices(:,1)=Ax*ProbeCenters.vertices(:,1)+Bx;
			ProbeCenters.vertices(:,2)=Ay*ProbeCenters.vertices(:,2)+By;
			ProbeCenters.vertices(:,3)=Az*ProbeCenters.vertices(:,3)+Bz;
			
			
			ProbeCenters.vertices=ProbeCenters.vertices';
			ProbeVDWperAtom=ProbeRadius*ones(size(ProbeCenters.vertices(1,:)));
% 			figure
% 			plot3(ProbeCenters.vertices(1,:),ProbeCenters.vertices(2,:),...
% 				ProbeCenters.vertices(3,:),'.');%!!!
% 			axis equal; axis vis3d;%!!!
% 			SuperpositionMode='AddMax';	%Atoms' densities will be substracted from the volume density (but not less than zero)
			SuperpositionMode='SubstractMax';	%Atoms' densities will be substracted from the volume density (but not less than zero)
%			SuperpositionMode='Substract';	%Atoms' densities will be substracted from the volume density (but not less than zero)
			BorderType='Linear';	%Border of the atom VDW volume in the range between two mesh bins on the border
%			BorderType='Sharp';	%Border of the atom VDW volume in the range between two mesh bins on the border
			
			VolmData=xyzVDW2volm(VolmData,ProbeCenters.vertices(1,:),ProbeCenters.vertices(2,:),...
				ProbeCenters.vertices(3,:),ProbeVDWperAtom,vMBinsX,vMBinsY,vMBinsZ,BorderType,...
				SuperpositionMode);	%Add VDW spheres of density 1 at atoms' positions to the empty volume.
% 			VolmData=xyzVDW2volm(zeros(size(VolmData)),ProbeCenters.vertices(1,:),ProbeCenters.vertices(2,:),...
% 				ProbeCenters.vertices(3,:),ProbeVDWperAtom,vMBinsX,vMBinsY,vMBinsZ,BorderType,...
% 				SuperpositionMode);	%Add VDW spheres of density 1 at atoms' positions to the empty volume
		end	%molecule surface determined by the sovent surface
		ProgressBarGlobal((m-1+0.6),length(s));%Set current value on the global progress bar
		
		%-------- Smoothing 3D data
		switch SmoothNeighb		%Option don't smooth the data, use Gaussian smoothing of volumetric data or multiple 1-neighbor smoothing 
		case 1	%don't smooth the data,
		case 2	%Gaussian smoothing
			VolmData = smooth3(VolmData,'gaussian',SmoothNeighbRange_box,SmoothNeighbRange_greed);
		case 3	%multiple 1-neighbor smoothing 
			for i=1:SmoothNeighbRange
				VolmData = smooth3(VolmData,'box',3);
			end
		end
		ProgressBarGlobal((m-1+0.8),length(s));%Set current value on the global progress bar

% 		figure;%!!!
% 		surf(VolmData(:,:,round(length(vMBinsZ)/2)));%!!!

		%-------- Visualize surface
		if PlotSurf==1	%Visualize surface
			figure
			Surface=isosurface(permute(VolmData,[2 1 3]),PlotSurfLevel);
			%%NOTE: X AND Y AXES ARE SWIPED TO COMPENSATE "isosurface" INTERNAL SWAP BEFORE
			%[Surface.vertices(:,1),Surface.vertices(:,2)]=swap(Surface.vertices(:,1),Surface.vertices(:,2));
			%Convert surface coordinates from volumetric data to their real values
			vMinX=min(vMBinsX); vMaxX=max(vMBinsX);
			vMinY=min(vMBinsY); vMaxY=max(vMBinsY);
			vMinZ=min(vMBinsZ); vMaxZ=max(vMBinsZ);
			Ax=(vMaxX-vMinX)/(size(VolmData,1)-1); Bx=vMinX-Ax;
			Ay=(vMaxY-vMinY)/(size(VolmData,2)-1); By=vMinY-Ay;
			Az=(vMaxZ-vMinZ)/(size(VolmData,3)-1); Bz=vMinZ-Az;
			Surface.vertices(:,1)=Ax*Surface.vertices(:,1)+Bx;
			Surface.vertices(:,2)=Ay*Surface.vertices(:,2)+By;
			Surface.vertices(:,3)=Az*Surface.vertices(:,3)+Bz;
			p = patch(Surface);
			set(p,'FaceColor',[0.8 1 1],'EdgeColor','none');
			daspect([1 1 1]); view(3); axis tight; camlight; lighting gouraud
			title(['Surface of the ',s{m},' at the p=',num2str(PlotSurfLevel),' level']);
			xlabel('X, A'); ylabel('Y, A'); zlabel('Z, A');
			
		end	%Visualize surface
		
		
		if MeanOfAllPDBs>1 %averaging among all the input structure files
			if length(FinalVolmData)==0
				FinalVolmData=VolmData;
			else
				FinalVolmData=(FinalVolmData*max(1,(mSet-1))+VolmData)/mSet;	%Adding new data. Dividing on the number of files added to normalize probability
			end
			if m==length(s)|mSet==MeanOfAllPDBs	%the last file of the last file in the set added
				VolmData=FinalVolmData;
                %clc=clock; clc=[sprintf('%02.0f',clc(4)),'h',sprintf('%02.0f',clc(5)),'m',sprintf('%02.0f',clc(6)),'s'];
				saveFileName=['Avrg_',num2str(mSet),'_fls_',s{m-mSet+1},'_to_',s{m},'_vol.mat'];
				tstr=['save ''',saveFileName,''' VolmData vMBinsX vMBinsY vMBinsZ;'];
				eval(tstr);
				if ZIPoutput==1
					zip([saveFileName,'.zip'],saveFileName);
					delete(saveFileName);
				end
				FinalVolmData=[];
				mSet=0;
			end
			mSet=mSet+1;	%counter for the next file in it's set
		else
			saveFileName=[s{m},'_vol.mat'];
			tstr=['save ''',saveFileName,''' VolmData vMBinsX vMBinsY vMBinsZ;'];
			eval(tstr);
			if ZIPoutput==1
				zip([saveFileName,'.zip'],saveFileName);
				delete(saveFileName);
			end
		end %averaging among all the input structure files
		current_time=now;
		time_left=(length(s)-m)*(current_time-initial_time)/m;
		disp([num2str(m),' of ',num2str(length(s)),'. ',s{m},':   ',num2str(length(ATOM.x)), '-atoms structure finished   ','Time left: ',my_datenum2str(time_left)]);

		SndNp(2);
		ProgressBarGlobal((m),length(s));%Set current value on the global progress bar
		
	end	%cycle through the structure files
	
	
	%beep;
	disp('Finished');
end	%End of all actions


