function ATOM = readGETAREAfull(fname1,DataType)
%this function d=reads PDB file into structure array
%input:
%fname1 - filename for PDB file
%DataType	- Data type in GetArea file: per residue <1>, per atom <2>.
%Output:
%ATOM - structure array with the fields corresponding to ones in ATOM record of PDB file

%fid = fopen (fname1,'r');
%numlines = 0; 
%ENDT = ' ';
%====ATOM strings reading
%while ENDT ~= 'END'
%	numlines = numlines + 1;
%	t = fgets (fid);
%	A (numlines,1:80)=' ';
%	A (numlines, 1:length(t)) = t;
%	ENDT = A (numlines, 1:3);
%end 
%fclose (fid);

TempZipFileName=unzip_AGA(fname1);  %Temporary Unzip file, if necesary

A={};
fid=fopen(fname1);
while 1
    tline = fgetl(fid);
    if ~ischar(tline); break; end
    A{end+1}=tline;
end
fclose(fid);

%A=textread(fname1,'%s','delimiter','\n');%,'whitespace','');
numlines=length(A);
t(1:80)=' '; t(1:length(A{1}))=A{1};
A{1}=t;
A=char(A);

switch DataType
case 1	%Per residue
	%============ATOM array initialization Total   Apolar  Backbone Sidechain Ratio(%) In/Out
	ATOM.resname={};	%       Residue name.
	ATOM.resid=[];	%        Residue sequence number.
	ATOM.energy=[];	%             area/energy.
	ATOM.apolar=[];	%        Atom serial number.
	ATOM.backbone=[];	%        backbone area/energy.
	ATOM.sidechain=[];	%        sidechain area/energy
	ATOM.ratio=[];	%        areas ratio in folded/unfolded protein 
	ATOM.inout={};	%          inner/undefined/exposed residue.
case 2	%Per atom
	%============ATOM array initialization
	ATOM.index=[];	%        Atom serial number.
	ATOM.name={};	%          Atom name.
	ATOM.resname={};	%       Residue name.
	ATOM.resid=[];	%        Residue sequence number.
	ATOM.energy=[];	%             area/energy.
end


StartReading=0;	%flag for beggining of data in the file
%=========== ATOM array filling out
for i = 1 : numlines
	if StartReading==0	%reading is not started
 		if (A(i,1:5)==' ATOM'|A(i,1:5)=='  Res')	%Header before the data
			StartReading=1;
		end
	else	%reading is started
 		if A(i,1:5)==' ----'	%line after the data
			break
		end
		if A(i,11:25)=='               '	%line after the data
			break
		end
		switch DataType
		case 1	%Per residue
			%============ATOM array initialization Total   Apolar  Backbone Sidechain Ratio(%) In/Out
			ATOM.resname{end+1}=sscanf(A(i,1:4),'%s');	%       Residue name.
			ATOM.resid(end+1)=sscanf(A(i,5:11),'%i');	%        Residue sequence number.
			ATOM.energy(end+1)=sscanf(A(i,12:20),'%f');	%             area/energy.
			ATOM.apolar(end+1)=sscanf(A(i,21:29),'%f');	%        Atom serial number.
			ATOM.backbone(end+1)=sscanf(A(i,30:38),'%f');	%        backbone area/energy.
			ATOM.sidechain(end+1)=sscanf(A(i,39:47),'%f');	%        sidechain area/energy
			ATOM.ratio(end+1)=sscanf(A(i,48:56),'%f');	%        areas ratio in folded/unfolded protein 
			ATOM.inout{end+1}=sscanf(A(i,57:62),'%s');;	%          inner/undefined/exposed residue.
		case 2	%Per atom
			%============ATOM array initialization
			ATOM.index(end+1)=sscanf(A(i,1:6),'%i');	%        Atom serial number.
			ATOM.name{end+1}=sscanf(A(i,7:11),'%s');	%          Atom name.
			ATOM.resname{end+1}=sscanf(A(i,12:15),'%s');	%       Residue name.
			ATOM.resid(end+1)=sscanf(A(i,16:21),'%i');	%        Residue sequence number.
			ATOM.energy(end+1)=sscanf(A(i,22:30),'%f');	%             area/energy.
		end
	end
end
% ATOM
disp([fname1,': --> ', num2str(length(ATOM.resname)), ' lines GETAREA structure read']);
%plot(ATOM.x)%!

unzip_AGA(fname1,TempZipFileName);  %Remove Temporary Unzip file, if necesary
