function	M_r=rotation_matrix_3x3(rotation_axis,angle);
%Function produces 3x3 rotation matrix around given axis for given angle (conterclockwise looking from the positive side)
a_r=rotation_axis(1);
b_r=rotation_axis(2);
c_r=rotation_axis(3);
abc_r=(a_r^2+b_r^2+c_r^2)^0.5;	%Length of rotation axis vector
cosA_r=a_r/abc_r;	%cosine with positive X axis
cosB_r=b_r/abc_r;	%cosine with positive Y axis
cosC_r=c_r/abc_r;	%cosine with positive Z axis
cosR=cos(angle);
sinR=sin(angle);

%Define rotation matrix
M_r=[   cosA_r^2*(1-cosR)+cosR, 			cosA_r*cosB_r*(1-cosR)-cosC_r*sinR, 	cosA_r*cosC_r*(1-cosR)+cosB_r*sinR;...
		cosA_r*cosB_r*(1-cosR)+cosC_r*sinR, cosB_r^2*(1-cosR)+cosR, 				cosB_r*cosC_r*(1-cosR)-cosA_r*sinR;...
		cosA_r*cosC_r*(1-cosR)-cosB_r*sinR, cosB_r*cosC_r*(1-cosR)+cosA_r*sinR, 	cosC_r^2*(1-cosR)+cosR];
