function 	VolmData=xyzVDW2volm(VolmData,ATOM_x,ATOM_y,ATOM_z,VDWperAtom,...
	vMBinsX,vMBinsY,vMBinsZ,BorderType,SuperpositionMode);	%Add VDW spheres of density 1 at atoms' positions to the empty volume

BinWidth=vMBinsX(2)-vMBinsX(1);	%It is supposed that volumetric mesh is equalspaced	
sBinWidth=BinWidth/2;
tic; ProgressReportTime=toc; numlines=length(ATOM_x);

for i=1:length(ATOM_x)	%cycle through all the atoms
	if strcmp(BorderType,'Single')
		%Find bins in the reasonable range and create a subvolume indices
		x=min(find(vMBinsX>(ATOM_x(i)-sBinWidth)&vMBinsX<=(ATOM_x(i)+sBinWidth)));
		y=min(find(vMBinsY>(ATOM_y(i)-sBinWidth)&vMBinsY<=(ATOM_y(i)+sBinWidth)));
		z=min(find(vMBinsZ>(ATOM_z(i)-sBinWidth)&vMBinsZ<=(ATOM_z(i)+sBinWidth)));
		p=1;
        switch SuperpositionMode	%The way new atom density will be added to the volume
        case 'Add'
            VolmData(x,y,z)=VolmData(x,y,z)+p;
        case 'AddMax'
            VolmData(x,y,z)=max(VolmData(x,y,z),p);
        case 'Substract'
            VolmData(x,y,z)=max(0,(VolmData(x,y,z)-p));
        end
	else
		%Find bins in the reasonable range and create a subvolume indices
		f_vMBinsX=find(vMBinsX>(ATOM_x(i)-(VDWperAtom(i)+BinWidth))&...
			vMBinsX<=(ATOM_x(i)+(VDWperAtom(i)+BinWidth)));
		f_vMBinsY=find(vMBinsY>(ATOM_y(i)-(VDWperAtom(i)+BinWidth))&...
			vMBinsY<=(ATOM_y(i)+(VDWperAtom(i)+BinWidth)));
		f_vMBinsZ=find(vMBinsZ>(ATOM_z(i)-(VDWperAtom(i)+BinWidth))&...
			vMBinsZ<=(ATOM_z(i)+(VDWperAtom(i)+BinWidth)));
		
		for x=f_vMBinsX	%z in subvolume
			for y=f_vMBinsY	%y in subvolume
				for z=f_vMBinsZ	%z in subvolume
					%supposed atom probability to occur
					switch BorderType
					case 'Linear'
						d=((vMBinsX(x)-ATOM_x(i))^2+(vMBinsY(y)-ATOM_y(i))^2+(vMBinsZ(z)-ATOM_z(i))^2)^0.5;	%distance from the bin to the atom center
						p=min(1,max(0,((VDWperAtom(i)-d)/BinWidth+0.5)));
					case 'Sharp'
						d=((vMBinsX(x)-ATOM_x(i))^2+(vMBinsY(y)-ATOM_y(i))^2+(vMBinsZ(z)-ATOM_z(i))^2)^0.5;	%distance from the bin to the atom center
						if d<=VDWperAtom(i)	%Bin within atom VDW radius
							p=1;
						else	%Bin out of atom VDW radius
							p=0;
						end
					case 'Mini'
						p=max(0,(1-abs(vMBinsX(x)-ATOM_x(i))/BinWidth))*...
							max(0,(1-abs(vMBinsY(y)-ATOM_y(i))/BinWidth))*...
							max(0,(1-abs(vMBinsZ(z)-ATOM_z(i))/BinWidth));
					end
					
					switch SuperpositionMode	%The way new atom density will be added to the volume
					case 'Add'
						VolmData(x,y,z)=min(1,(VolmData(x,y,z)+p));
					case 'AddMax'
						VolmData(x,y,z)=min(1,max(VolmData(x,y,z),p));
					case 'Substract'
						VolmData(x,y,z)=max(0,(VolmData(x,y,z)-p));
					case 'SubstractMax'
						VolmData(x,y,z)=min(VolmData(x,y,z),(1-p));
					end
					
				end	%z in subvolume
			end	%y in subvolume
		end	%z in subvolume
	end	%If atom fits in single cell
	
	%Progress report block - optional
	CurrentProgressTime=toc;
	if (CurrentProgressTime-ProgressReportTime)>0.5	%Time to report progress
		try ProgressBarLocal(i,numlines);%Set current value on the local progress bar
		end
		ProgressReportTime=CurrentProgressTime;
	end	%Time to report progress

end	%cycle through all the atoms
ProgressBarLocal(100,100);%Set current value on the local progress bar
